/*
 * Created on May 1, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package bt;

import java.io.File;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;
//import org.apache.tools.ant.taskdefs.Javac;
import org.apache.tools.ant.types.Path;
import org.xml.sax.Attributes;

/**
 * @author snshor
 *
 */
public class AntEclipseProjectTask extends Task
{

  String projectDir;
  String projectName;
  String buildDir;

  public void execute() throws BuildException
  {
    prepareProject();
  }

  /**
   * @return
   */
  public String getProjectDir()
  {
    return projectDir;
  }

  /**
   * @param string
   */
  public void setProjectDir(String string)
  {
    projectDir = string;
  }

  /**
   * @return
   */
  public String getProjectName()
  {
    return projectName;
  }

  /**
   * @param string
   */
  public void setProjectName(String string)
  {
    projectName = string;
  }

  static HashMap projectMap = new HashMap();

  void prepareProject() throws BuildException
  {

    EclipseProjectInfo pinfo = loadProject(projectDir, projectName);

//    Javac javacTask = new Javac();
//    javacTask.setProject(getProject());

//    Path srcpath =
//      new Path(getProject(), projectDir + "/" + projectName + "/src");
//      
//    getProject().setProperty(projectName+".srcpath", projectDir + "/" + projectName + "/src");  






//    srcpath.addExisting(
//      new Path(getProject(), projectDir + "/" + projectName + "/tst"));
      
      

    Path classpath = new Path(getProject());
    
    HashSet libraries = createProjectLibraries(pinfo, new HashSet(), new HashSet());
    
    for (Iterator iter = libraries.iterator(); iter.hasNext();)
    {
      String pathElement = (String)iter.next();
      classpath.addExisting(new Path(getProject(),pathElement));
    }
    
    getProject().setProperty("eclipse.project.classpath", classpath.toString());
    //System.out.println("Classpath = " + classpath.toString());
    
    
    
//    javacTask.setClasspath(classpath);
//
//    javacTask.setSrcdir(srcpath);

//    if (buildDir == null)
//    {
//      buildDir = projectDir;
//    }
//
//    File destDir = new File(buildDir + "/" + projectName + "/classes");
//    destDir.mkdirs();
//    javacTask.setDestdir(destDir);
//
//    javacTask.execute();

  }

  EclipseProjectInfo loadProject(String pdir, String pname)
    throws BuildException
  {
    //  	if (projectDir == null)
    //  		throw new BuildException("projectDir has not been set")
    //  		
    //	if (projectName == null)
    //		throw new BuildException("projectName has not been set")

    EclipseProjectInfo pinfo = new EclipseProjectInfo();
    pinfo.setName(pname);

    File fproject = new File(pdir + "/" + pname + "/.project");
    File fclasspath = new File(pdir + "/" + pname + "/.classpath");

    SimpleXMLExtractor sxProject = new SimpleXMLExtractor();
    sxProject.registerHandler("project", new ProjectsHandler(pinfo));

    SimpleXMLExtractor sxClasspath = new SimpleXMLExtractor();
    sxClasspath.registerHandler("classpathentry", new LibPathHandler(pinfo));

    try
    {
      sxProject.parse(fproject);
    }
    catch (Throwable t)
    {
      throw new BuildException("Error reading .project file", t);
    }

    try
    {
      sxClasspath.parse(fclasspath);
    }
    catch (Throwable t)
    {
      throw new BuildException("Error reading .classpath file", t);
    }

    return pinfo;
  }

  static class LibPathHandler extends SimpleXMLExtractor.Handler
  {

    EclipseProjectInfo pinfo;

    LibPathHandler(EclipseProjectInfo pinfo)
    {
      this.pinfo = pinfo;
    }

    public void handleAttributes(Attributes attrs)
    {
    	
//      System.out.println("Classpathentry "  + attrs.getValue("kind") + " " + 
//			attrs.getValue("path"));	
    	
      if (!"lib".equals(attrs.getValue("kind")))
        return;

      pinfo.getLibpath().add(attrs.getValue("path"));

    }

  }

  HashSet createProjectLibraries(
    EclipseProjectInfo pinfo,
    HashSet libraries,
    HashSet projects)
  {
 
 
  	
//  	System.out.println("Getting libraries from " + pinfo.getName());
    if (projects.contains(pinfo.getName()))
      return libraries;

	String propFrom = getProject().getProperty("lib.replace.from");
	String propTo = getProject().getProperty("lib.replace.to");
    for (Iterator iter = pinfo.getLibpath().iterator(); iter.hasNext();)
    {
      String lib = (String)iter.next();
      if (propFrom != null && propFrom.length() > 0 && lib.startsWith(propFrom))
      {
      	lib = propTo + lib.substring(propFrom.length());  	
      }
      libraries.add(lib);
    }
//    libraries.addAll(pinfo.getLibpath());
    projects.add(pinfo.getName());

    for (Iterator iter = pinfo.getDepProjects().iterator(); iter.hasNext();)
    {
      String prjName = (String)iter.next();
	  System.out.println("dependent " + prjName);
      if (projects.contains(prjName))
      	continue;
      libraries.add(buildDir + "/" + prjName + "/classes");	
      EclipseProjectInfo prj = loadProject(projectDir, prjName);	
      libraries = createProjectLibraries(prj, libraries, projects);
    }

    return libraries;
  }

  static class ProjectsHandler extends SimpleXMLExtractor.Handler
  {

    EclipseProjectInfo pinfo;

    ProjectsHandler(EclipseProjectInfo pinfo)
    {
      this.pinfo = pinfo;
    }

    public void handleChars(String chars)
    {
      pinfo.getDepProjects().add(chars);
    }

  }

  /**
   * @return
   */
  public String getBuildDir()
  {
    return buildDir;
  }

  /**
   * @param string
   */
  public void setBuildDir(String string)
  {
    buildDir = string;
  }

}
