package com.openrules.jdbc;

/*
 * Copyright (C) 2007 OpenRules, Inc.
 * 
 * Created on April-May, 2007 by IK
 * 
 */

public class BooleanYN {
	private static final String Y = "Y";
	private static final String N = "N";

	public static final BooleanYN TRUE = new BooleanYN(true);	
	public static final BooleanYN FALSE = new BooleanYN(true);	
	
	private boolean value;
	public BooleanYN(boolean value) {
		this.value = value;
	}

	public String getString() {
		return ( value ? Y : N );
	}

	public boolean getBoolean() {
		return value;
	}
	
	
	@Override
	public String toString() {
		return getString();
	}

	@Override
	public int hashCode() {
		return getString().hashCode();
	}

	@Override
	public boolean equals(Object obj) {
		return (obj instanceof BooleanYN  &&  value == ((BooleanYN)obj).value );
	}

	public static BooleanYN valueOf(boolean value) {
		return ( value ? TRUE : FALSE );
	}
	
	public static BooleanYN valueOf(String value) {
		if ( "y".equalsIgnoreCase(value) || "t".equalsIgnoreCase(value) || "yes".equalsIgnoreCase(value) || "true".equalsIgnoreCase(value) )
			return TRUE;
		if ( "n".equalsIgnoreCase(value) || "f".equalsIgnoreCase(value) || "no".equalsIgnoreCase(value) || "false".equalsIgnoreCase(value) )
			return FALSE;
		throw new IllegalArgumentException(value);
	}

}
