package com.openrules.jdbc;

/*
 * Copyright (C) 2007 OpenRules, Inc.
 * 
 * Created on April-May, 2007 by IK
 * 
 */

import java.sql.Blob;
import java.sql.Clob;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;

public class SelectHelper {

	private ResultSet rs;

	public SelectHelper(ResultSet rs) {
		this.rs = rs;
	}

	public String getString(String name) throws SQLException {
		String s = rs.getString(name);
		return (rs.wasNull() ? null : s);
	}

	//support boolean for a string property with 'Y' for true and 'N' for false
	public Boolean getBooleanYN(String name) throws SQLException {
		String s = rs.getString(name);
		return ( s == null ? null : "Y".equals(s) ? Boolean.TRUE : Boolean.FALSE );
	}

	public Integer getInteger(String name) throws SQLException {
		int i = rs.getInt(name);
		return (rs.wasNull() ? null : i);
	}

	public String getClob(String name) throws SQLException {
		Clob clob = rs.getClob(name);
		if (rs.wasNull())
			return null;
		return clob.getSubString(1, (int)clob.length() );
	}

	public byte[] getBlob(String name) throws SQLException {
		Blob blob = rs.getBlob(name);
		if (rs.wasNull())
			return null;
		return blob.getBytes(1, (int) blob.length());
	}

	public Timestamp getTimestamp(String name) throws SQLException {
		Timestamp ts = rs.getTimestamp(name);
		return (rs.wasNull() ? null : ts);
	}
}
