package com.openrules.db.admin;

/*
 * Copyright (C) 2007 OpenRules, Inc.
 * 
 * Created on April-May, 2007 by IK
 * Modified by JF
 * 
 */

import java.util.Properties;
import com.openrules.dao.DaoUtils;

public class DaoConfig {

	private Dao dao;

	public void dispose() {
		if (dao != null) {
			dao.dispose();
		}
	}

	public Dao getDao() {
		if (dao == null)
			init();
		return dao;
	}

	private static final String DB_PROPERTY_VAR = "DB_PROPERTIES";
	
	public void init() {
		// Properties props = Utils.loadPropertiesFromClasspath(getClass(),"/conf/dbloader.properties" );
		String fileName = System.getProperty(DB_PROPERTY_VAR, "db.properties");
		Properties props = DaoUtils.loadPropertiesFromFile(fileName);
		dao = new Dao();
		dao.initialize(props);
	}

}
