package com.openrules.dbv.admin;

/*
 * Copyright (C) 2007 OpenRules, Inc.
 * 
 * Created on April-May, 2007 by IK
 * Modified by JF
 * 
 */

import java.util.List;
import java.util.Properties;

import com.openrules.dao.DAOException;

public interface RepoDAO {
	
	public void initialize(Properties options) throws DAOException;
	
	public void dispose();
	
	public List<RepoEntry> findAll( String nameMask, int revision ) throws DAOException;
	
	public RepoEntry findEntry( String name, int revision ) throws DAOException;
	
	public int addEntry(String name, byte[] content, String author, String comment ) throws DAOException;
	
	public int removeEntry( String name, String author, String comment ) throws DAOException;
	
	public List history(String name) throws DAOException;
	
	public int revision() throws DAOException;

	public void createRepository() throws DAOException;
	
}
