package com.openrules.dbv.admin;

/*
 * Copyright (C) 2007 OpenRules, Inc.
 * 
 * Created on April-May, 2007 by IK
 * Modified by JF
 */

/**
 * System variable REPOSITORY_ROOT defines a path for the common root for all
 * rules repositories
 * 
 */

//import java.io.IOException;
//import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import com.openrules.dao.DAOException;
import com.openrules.dao.DaoOptions;
import com.openrules.dao.DaoUtils;

public class RepositoryMap {

	protected Map<String,RepoDAO> repos = new HashMap<String,RepoDAO>();

//	private static final String REPOSITORY_ROOT_VAR = "REPOSITORY_ROOT";
	
	protected Properties getConfiguration( String configId ) {
//		String repoName = String.format("/config/%s.properties", configId );
//		InputStream is = getResourceAsStream(repoName);
//		if (is == null)
//			throw new DAOException(String.format("Repository properties %s not found in classpath", repoName ) );
//		Properties props = new Properties();
//		try {
//			props.load( is );
//			
//		} catch (IOException e) {
//			throw new DAOException( String.format("Error while reading '%s'", repoName), e);
//
//		} finally {
//			Utils.close(is);
//		}
		
//		String repoRoot = System.getProperty(REPOSITORY_ROOT_VAR, "rules");
//		String repoName = String.format(repoRoot+"/%s.properties", configId );
		String propFileName = System.getProperty(DaoOptions.DB_PROPERTY_VAR, "rules/main/db.properties");
		Properties props = DaoUtils.loadPropertiesFromFile(propFileName);
		
		return props;
	}
	
//	protected InputStream getResourceAsStream( String path ) {
//		return getClass().getResourceAsStream( path );
//	}
	
	protected RepoDAO initDAO(String configId )  {
		
		Properties props = getConfiguration(configId);
		
		String daoClassName = props.getProperty( DaoOptions.IMPLEMENTATION_CLASS );
		if ( daoClassName == null )
			throw new DAOException("Undefined DAO implementation class name");
		
		RepoDAO dao = DaoUtils.newInstance(daoClassName);
		dao.initialize(props);
		
		repos.put( configId, dao );
		
		return dao;
	}

	
	public RepoDAO getDAO(String configId) {
		RepoDAO dao = repos.get(configId);
		if ( dao == null ) 
			dao = initDAO(configId);
		return dao;
	}

	/**
	 * 
	 */
	public void dispose() {
		for ( RepoDAO dao : repos.values() ) {
			try { 
				dao.dispose();
			} catch ( Throwable t ) {
				//ignored
			}
		}
		repos.clear();
	}

}
