package com.openrules.core.expressions;

/*
 * Copyright (C) 2006 OpenRules, Inc.
 * 
 */

import org.eclipse.core.expressions.PropertyTester;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.Assert;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jdt.core.IJavaProject;
import org.osgi.framework.Bundle;

import com.openrules.eclipse.core.plugin.OpenrulesPlugin;

public class JavaProjectTester extends PropertyTester {
	private static final String NATURE = "projectNature"; //$NON-NLS-1$

	public JavaProjectTester() {
	}

	public boolean test(Object receiver, String property, Object[] args,
			Object expectedValue) {
		IJavaProject project = (IJavaProject) receiver;
		if (NATURE.equals(property)) {
			IProject p = project.getProject();
			try {
				return p.hasNature((String) expectedValue);
			} catch (CoreException e) {
				//ignore
			}
		}
		Assert.isTrue(false);
		return false;
	}

	public boolean isDeclaringPluginActive() {
		return  OpenrulesPlugin.getDefault().getBundle().getState() == Bundle.ACTIVE;
	}
	
}
