/*
 * Created on Dec 23, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */
 
package com.openrules.eclipse.xls.launching;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;

/**
 * @author snshor
 *
 */
public class SourceCodeURLTool implements SourceCodeURLConstants
{
	static public Map parseUrl(String urls)
	{
		HashMap map = new HashMap();
		
		
		try
		{
			URL url = new URL(urls);	
			String file = url.getFile();
			String protocol = url.getProtocol();
			String host=url.getHost();
			String query = url.getQuery();
			
			int indexQuestionMark = file.indexOf('?');
			file = indexQuestionMark < 0 ? file : file.substring(0, indexQuestionMark);
			
			map.put(PROTOCOL, protocol);
			map.put(HOST, host);
			map.put(FILE, file);

			parseQuery(query, map);
		}
		catch (MalformedURLException e)
		{
			map.put(ERROR, e.getMessage());
		}
		
		
		return map;
	}
	
	static void parseQuery(String query, Map map)
	{
		StringTokenizer st = new StringTokenizer(query, QSEP);
		
		while(st.hasMoreTokens())
		{
			String pair = st.nextToken();
			
			int idx = pair.indexOf('=');
			
			if (idx < 0)
			{
				map.put(pair, "");
			}
			else
			{
				String key = pair.substring(0, idx); 
				String value = pair.substring(idx + 1, pair.length()); 
				map.put(key, value);
			}
		}		
		
	}

}
