/*
 * Created on Sep 5, 2003
 *
 * Developed by OpenRules Inc. 2003
 */

package com.openrules.eclipse.xls.launching;

import org.eclipse.jface.text.BadLocationException;
import org.eclipse.ui.console.IHyperlink;
import org.eclipse.ui.console.IPatternMatchListener;
import org.eclipse.ui.console.PatternMatchEvent;
import org.eclipse.ui.console.TextConsole;

public class XlsConsoleListener implements IPatternMatchListener	{

	public int getCompilerFlags() {
		return 0;
	}

	public String getLineQualifier() {
		return null;
	}

	public String getPattern() {
		return "file:/[\\S ]*";
	}

	public void connect(TextConsole console) {
	}

	public void disconnect() {
	}

	public void matchFound(PatternMatchEvent event) {
		TextConsole tc = (TextConsole) event.getSource();
		int offset = event.getOffset();
		int length = event.getLength();
		try {
			String text = tc.getDocument().get(offset, length);
			String url = text;
			IHyperlink link = new XlsHyperlink( url );
			tc.addHyperlink(link, offset, length);
		} catch (BadLocationException e) {
			//ignore
		}
		
	}

}
