/*
 * Created on Dec 23, 2003
 *
 * Developed by OpenRules Inc. 2003
 */

package com.openrules.eclipse.xls.launching;

import java.io.File;
import java.net.URL;
import java.util.Map;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Path;

import com.openrules.eclipse.core.plugin.OpenrulesPlugin;

/**
 * 
 * @author sam
 * @author IK
 */

public class XlsUrlParser  {

	private static final Object SHEET = "sheet";
	private static final Object RANGE = "range";
	private static final Object FILE = "file";
	private static final Object CELL = "cell";
	private static final String SCRIPT_NAME = "LaunchExcel.vbs";

	public String scriptName;

	public String wbPath;
	public String wbName;
	public String wsName;
	public String range;

	public void parse(String url) throws Exception {

		URL bundleUrl = FileLocator.find( OpenrulesPlugin.getDefault().getBundle(), new Path( SCRIPT_NAME ) , null );
		scriptName =  FileLocator.toFileURL(bundleUrl).toExternalForm().substring( "file:/".length() );

		Map urlMap = SourceCodeURLTool.parseUrl(url);

		String file = (String) urlMap.get(FILE);
		wsName = (String) urlMap.get(SHEET);
		range = (String) urlMap.get(RANGE);

		if (range == null) {
			range = (String) urlMap.get(CELL);
		}

		File f = new File(file).getCanonicalFile();

		wbPath = f.getParent();
		wbName = f.getName();

	}

}
