package com.openrules.eclipse.util;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;

import org.eclipse.ant.core.AntRunner;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;

/**
 * @author smesh
 */
public class AntUtil {

	static public void runAnt(String buildFileLocation, Properties properties,
			IProgressMonitor monitor) throws CoreException {
		try {
			monitor.beginTask("", 2000);

			AntRunner runner = new AntRunner();

			runner.setBuildFileLocation(buildFileLocation);

			// set arguments
			Collection args = new ArrayList();
			for (Iterator it = properties.entrySet().iterator(); it.hasNext();) {
				Map.Entry entry = (Map.Entry) it.next();
				args.add("-D" + entry.getKey() + "=" + entry.getValue());
			}
			args.add("-verbose");

			runner.setArguments((String[]) args
					.toArray(new String[args.size()]));

			runner.run(monitor);

			// wait
			while (AntRunner.isBuildRunning()) {
				try {
					Thread.currentThread().wait(1000);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
				}
				monitor.worked(1);
			}
		} finally {
			monitor.done();
		}
	}

}