package com.openrules.eclipse.util;

import java.io.File;
import java.net.URL;

import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Platform;
import org.osgi.framework.Bundle;

/**
 * @author smesh
 */
public class UrlUtil {

	static public URL getCanonicalUrl(String bundleName, String localPath)
			throws Exception {

		Bundle bundle = Platform.getBundle(bundleName);

		if (bundle == null) {
			throw new RuntimeException("Bundle does not exist: '" + bundleName
					+ "'");
		}

		URL url = Platform.find(bundle, new Path(localPath));

		if (url == null) {
			throw new RuntimeException("Path '" + localPath
					+ "' does not exists in the bundle '" + bundleName + "'");
		}

		return Platform.resolve(url);
	}

	static public String getPathForFileUrl(URL url) throws Exception {
		String path = url.getPath();

		URL fileUrl = new File(path).toURL();

		if (!fileUrl.equals(url))
			throw new Exception("URL '" + url + "' should be 'file:' URL");

		return path;
	}
}