package com.openrules.jsr94.rules;

import java.util.List;
import java.util.Map;

import javax.rules.RuleExecutionSetNotFoundException;
import javax.rules.RuleRuntime;
import javax.rules.RuleSession;
import javax.rules.RuleSessionTypeUnsupportedException;

import com.openrules.jsr94.rules.admin.RuleExecutionSetRepository;

public class RuleRuntimeImpl implements RuleRuntime
{
    public RuleSession createRuleSession(
            String uri, Map properties, int ruleSessionType )
        throws RuleSessionTypeUnsupportedException,
               RuleExecutionSetNotFoundException
    {

        if ( ruleSessionType == RuleRuntime.STATELESS_SESSION_TYPE )
        {
            StatelessRuleSessionImpl session =
                new StatelessRuleSessionImpl( uri, properties );
            return session;
        }

        if ( ruleSessionType == RuleRuntime.STATEFUL_SESSION_TYPE )
        {
            StatefulRuleSessionImpl session =
                new StatefulRuleSessionImpl( uri, properties );
            return session;
        }

        throw new RuleSessionTypeUnsupportedException(
            "invalid session type: " + ruleSessionType );
    }

    public List getRegistrations( )
    {
        RuleExecutionSetRepository repository =
            RuleExecutionSetRepository.getInstance( );
        return repository.getRegistrations( );
    }
}
