package com.openrules.jsr94.rules;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

import javax.rules.InvalidRuleSessionException;
import javax.rules.ObjectFilter;
import javax.rules.RuleExecutionSetNotFoundException;
import javax.rules.StatelessRuleSession;

public class StatelessRuleSessionImpl extends ARuleSession implements
		StatelessRuleSession {

	public StatelessRuleSessionImpl(String bindUri, Map properties)
			throws RuleExecutionSetNotFoundException {
		super(bindUri, properties);
	}

	public List executeRules(List objects) throws InvalidRuleSessionException {
		return executeRules(objects, getDefaultObjectFilter());
	}
	
	public List executeRules(List objects, ObjectFilter filter)
			throws InvalidRuleSessionException {
		return applyFilter(executeRulesInternal(objects), filter);
	}

	protected List executeRulesInternal(List objects)
			throws InvalidRuleSessionException {
		
		Object[] objectsArray = objects.toArray();
		Map properties = getProperties();
		String method = (String)properties.get("method");
		Object result;
		if (method == null)
			result = ruleExecutionSet.getRuleEngine().run(objectsArray);
		else
			result = ruleExecutionSet.getRuleEngine().run(method, objectsArray);
		return Arrays.asList(objectsArray);
	}

}