package com.openrules.jsr94.rules.admin;

import java.util.Map;

import javax.rules.admin.LocalRuleExecutionSetProvider;
import javax.rules.admin.RuleAdministrator;
import javax.rules.admin.RuleExecutionSet;
import javax.rules.admin.RuleExecutionSetDeregistrationException;
import javax.rules.admin.RuleExecutionSetProvider;
import javax.rules.admin.RuleExecutionSetRegisterException;

public class RuleAdministratorImpl implements RuleAdministrator {

	public RuleExecutionSetProvider getRuleExecutionSetProvider(Map properties) {
		return new RuleExecutionSetProviderImpl();
	}

	public LocalRuleExecutionSetProvider getLocalRuleExecutionSetProvider(
			Map properties) {
		return new LocalRuleExecutionSetProviderImpl();
	}

	public void registerRuleExecutionSet(String bindUri, RuleExecutionSet set,
			Map properties) throws RuleExecutionSetRegisterException {
		RuleExecutionSetRepository.getInstance().registerRuleExecutionSet(
				bindUri, set);
	}

	public void deregisterRuleExecutionSet(String bindUri, Map properties)
			throws RuleExecutionSetDeregistrationException {
		RuleExecutionSetRepository.getInstance().unregisterRuleExecutionSet(
				bindUri);
	}
}