package com.openrules.jsr94.rules.admin;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.rules.admin.RuleExecutionSet;

import com.openrules.ruleengine.OpenRulesEngine;

public class RuleExecutionSetImpl implements RuleExecutionSet {

	private String name;

	private String description;

	private String defaultObjectFilter;

	private Map properties;

	protected OpenRulesEngine ruleEngine;

	public RuleExecutionSetImpl(String fileName, Map properties) {
		this.properties = properties != null ? properties : new HashMap();

		String methodName = (String) properties.get("method");
		if (methodName == null) {
			methodName = (String) properties.get("main");
		}
		
		OpenRulesEngine externalEngine = (OpenRulesEngine) properties.get("RuleEngine");
		if (externalEngine == null)	{
			//System.out.println("Create default engine");
			ruleEngine = new OpenRulesEngine(fileName);
			if (methodName != null)
				ruleEngine.setMethod(methodName);
		}
		else {
			//System.out.println("Create engine define through property");
			ruleEngine = externalEngine;
		}
		//System.out.println("Rule Engine Created");
	}

	public String getName() {
		return name;
	}

	public String getDescription() {
		return this.description;
	}

	public Object getProperty(Object key) {
		return properties.get(key);
	}

	public void setProperty(Object key, Object value) {
		properties.put(key, value);
	}

	public void setDefaultObjectFilter(String defaultObjectFilter) {
		this.defaultObjectFilter = defaultObjectFilter;
	}

	public String getDefaultObjectFilter() {
		return defaultObjectFilter;
	}

	public List getRules() {
		List rules = new ArrayList();
		return rules;
	}

	public OpenRulesEngine getRuleEngine() {
		return ruleEngine;
	}
	
}