package com.openrules.jsr94.rules.admin;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.rules.admin.RuleExecutionSet;
import javax.rules.admin.RuleExecutionSetRegisterException;

public final class RuleExecutionSetRepository {

	private static RuleExecutionSetRepository instance;

	private Map ruleSets = new HashMap();

	private RuleExecutionSetRepository() {
	}

	public static synchronized RuleExecutionSetRepository getInstance() {
		if (instance == null) {
			instance = new RuleExecutionSetRepository();
		}
		return instance;
	}

	public List getRegistrations() {
		List list = new ArrayList();
		list.addAll(ruleSets.keySet());
		return list;
	}

	public RuleExecutionSet getRuleExecutionSet(String bindUri) {
		return (RuleExecutionSet) ruleSets.get(bindUri);
	}

	public void registerRuleExecutionSet(String bindUri,
			RuleExecutionSet ruleSet) throws RuleExecutionSetRegisterException {
		if (bindUri == null) {
			throw new RuleExecutionSetRegisterException(
					"bindUri cannot be null");
		}
		if (ruleSet == null) {
			throw new RuleExecutionSetRegisterException(
					"ruleSet cannot be null");
		}
		ruleSets.put(bindUri, ruleSet);
	}

	public void unregisterRuleExecutionSet(String bindUri) {
		if (bindUri == null) {
			throw new NullPointerException("bindUri cannot be null");
		}
		ruleSets.remove(bindUri);
	}
}