package test;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.rules.RuleRuntime;
import javax.rules.RuleServiceProvider;
import javax.rules.RuleServiceProviderManager;
import javax.rules.StatelessRuleSession;
import javax.rules.admin.RuleAdministrator;
import javax.rules.admin.RuleExecutionSet;
import javax.rules.admin.RuleExecutionSetProvider;

/**
 * @author smesh
 */
public class Test {

	static public void main(String[] args) throws Exception {
		new Test().run();
	}

	public void run() throws Exception {

		// register RuleServiceProvider
		String ruleServiceProviderUri = "com.openrules.jsr94.rules.RuleServiceProviderImpl";
		Class RuleServiceProviderClass = com.openrules.jsr94.rules.RuleServiceProviderImpl.class;
		RuleServiceProviderManager.registerRuleServiceProvider(
				ruleServiceProviderUri, RuleServiceProviderClass);

		// get RuleServiceProvider from RuleServiceProviderManager
		RuleServiceProvider ruleServiceProvider = RuleServiceProviderManager
				.getRuleServiceProvider(ruleServiceProviderUri);

		// get RuleAdministrator from RuleServiceProvider
		RuleAdministrator ruleAdministrator = ruleServiceProvider
				.getRuleAdministrator();

		// get RuleExecutionSetProvider from RuleAdministrator
		Map ruleExecutionSetProviderProperties = new HashMap();
		RuleExecutionSetProvider ruleSetProvider = ruleAdministrator
				.getRuleExecutionSetProvider(ruleExecutionSetProviderProperties);

		// create RuleExecutionSet from ruleExecutionSetFileUri
		String ruleExecutionSetFileUri = "test/test.xls";
		Map ruleExecutionSetCreationProperties = new HashMap();
		ruleExecutionSetCreationProperties.put("main", "println");
		RuleExecutionSet ruleExecutionSet = ruleSetProvider
				.createRuleExecutionSet(ruleExecutionSetFileUri,
						ruleExecutionSetCreationProperties);

		// register/bind the RuleExecutionSet as ruleExecutionSetBindUri
		String ruleExecutionSetBindUri = "test";
		Map ruleExecutionSetRegistrationProperties = new HashMap();
		ruleAdministrator.registerRuleExecutionSet(ruleExecutionSetBindUri,
				ruleExecutionSet, ruleExecutionSetRegistrationProperties);

		// get RuleRuntime from RuleServiceProvider
		RuleRuntime ruleRuntime = ruleServiceProvider.getRuleRuntime();

		// create StatelessRuleSession in RuleRuntime
		Map ruleSessionProperties = new HashMap();
		StatelessRuleSession statelessRuleSession = (StatelessRuleSession) ruleRuntime
				.createRuleSession(ruleExecutionSetBindUri,
						ruleSessionProperties,
						RuleRuntime.STATELESS_SESSION_TYPE);

		// execute rules
		Object[] args = { Arrays.asList(new Object[] { "1", "2", "3"}), };
		List result = statelessRuleSession.executeRules(Arrays.asList(args));
	}
}