/*
 *  
 *
 * Copyright (C) OpenRules, Inc. 2004-2006
 */
package com.openrules.forms.deployment;

import java.net.MalformedURLException;
import java.net.URL;

import org.openl.IOpenSourceCodeModule;
import org.openl.OpenL;
import org.openl.conf.IUserContext;
//import org.openl.syntax.impl.FileSourceCodeModule;
import org.openl.syntax.impl.URLSourceCodeModule;
import org.openl.types.IOpenClass;
import org.openl.util.RuntimeExceptionWrapper;
import org.openl.vm.IRuntimeEnv;

import com.openrules.datasource.DataSourceFactory;

public class ClassJavaWrapper {
	IOpenClass __class;

	IRuntimeEnv __env;

	public ClassJavaWrapper(IOpenClass clazz, IRuntimeEnv env) {
		__class = clazz;
		__env = env;
	}

	public InstanceJavaWrapper newInstance() {
		return new InstanceJavaWrapper(__class.newInstance(__env), this);
	}

	public IOpenClass getOpenClass() {
		return __class;
	}

	public IRuntimeEnv getEnv() {
		return __env;
	}

	// /factory methods

	static public ClassJavaWrapper createWrapper(String openlName,
			IUserContext ucxt, IOpenSourceCodeModule src) {
		OpenL openl = OpenL.getInstance(openlName, ucxt);

		IOpenClass openClass = openl.compileModule(src);

		return new ClassJavaWrapper(openClass, openl.getVm().getRuntimeEnv());
	}

	static public ClassJavaWrapper createWrapper(String openlName,
			IUserContext ucxt, String srcFile) {
		OpenL openl = OpenL.getInstance(openlName, ucxt);

		/*
		IOpenSourceCodeModule src = null;

		String fileOrURL = PropertiesLocator.locateFileOrURL(srcFile, ucxt
				.getUserClassLoader(), new String[] { ucxt.getUserHome() });

		if (fileOrURL == null)
			throw new RuntimeException("File " + srcFile + " is not found");

		try {
			if (fileOrURL.indexOf(':') < 2) // file
				src = new FileSourceCodeModule(fileOrURL, null);
			else
				src = new URLSourceCodeModule(new URL(fileOrURL));
		} catch (MalformedURLException e) {
			throw RuntimeExceptionWrapper.wrap(e);
		}
		*/
		URL source;
		try {
			source = getSourceURL(srcFile, ucxt);
		} catch (MalformedURLException e) {
			throw RuntimeExceptionWrapper.wrap(e);
		}
		
		IOpenSourceCodeModule src = (IOpenSourceCodeModule) new URLSourceCodeModule( source );

		IOpenClass openClass = openl.compileModule(src);

		return new ClassJavaWrapper(openClass, openl.getVm().getRuntimeEnv());

	}

	static public URL getSourceURL(String path, IUserContext ucxt)
			throws MalformedURLException {
		return new DataSourceFactory(null, ucxt).fromString(path).getUrl();
	}

}
