/*
 * Copyright (c) 2005-2006 OpenRules, Inc.
 */
package com.openrules.forms.jsp;

import java.io.File;

import com.openrules.forms.IFormsRequest;
import com.openrules.forms.IFormsSession;
import com.openrules.forms.IView;
import com.openrules.forms.gui.IGUIComponent;
import com.openrules.forms.gui.impl.ComponentList;
import com.openrules.forms.gui.impl.GUIComponent;
import com.openrules.forms.impl.ApplicationModel;
import com.openrules.forms.impl.ValueAdaptor;
import com.openrules.forms.impl.View;
import com.openrules.forms.xls.LayoutTableNodeBinder;
import com.openrules.lang.xls.XlsBinder;
import com.openrules.lang.xls.XlsLoader;
import com.openrules.ruleengine.OpenRulesEngine;
//import com.openrules.ruleengine.XlsRuleEngine;

/*
 * 7/19/05: JF removed methods inherited from ApplicationModel
 */
public class Test1040EZ extends ApplicationModel {

public IView updateView(IFormsRequest request, IFormsSession session) {
		View view = new View();

		view.setTopComponent(getTopComponent());
		return view;
	}

	/**
	 * @return
	 */
	private IGUIComponent getTopComponent() {
		GUIComponent form = makeComponent(new String[] { "form", null });

		ComponentList cl = new ComponentList();

		//		cl.addComponent(tc1());
		//		cl.addComponent(tc3("xyz"));
		cl.addComponent(ez1040("main"));

		form.setChildren(cl);
		return form;
	}

	OpenRulesEngine engine;

	long lastModified = 0;

	private IGUIComponent ez1040(String methodName) {

		String XLS_LAYOUT = "xls.layout";

		XlsLoader.tableHeaders().put("Layout", XLS_LAYOUT);

		XlsBinder.binderFactory().put(XLS_LAYOUT, new LayoutTableNodeBinder());

		String xlsName = "tst/org/openrules/forms/jsp/1040EZ.xls";

		File f = new File(xlsName);

		if (lastModified < f.lastModified()) {
			engine = new OpenRulesEngine(xlsName, methodName);
			lastModified = f.lastModified();
		}

		IGUIComponent gc = (IGUIComponent) engine.run(new Object[0]);

		return gc;
	}


	GUIComponent makeComponent(String[] tag_attrs) {
		GUIComponent gc = new GUIComponent();
		gc.setName(tag_attrs[0]);
		if (tag_attrs[1] != null) {
			gc.setDataModelAdaptor(new ValueAdaptor(tag_attrs[1]));
		}

		for (int i = 2; i < tag_attrs.length; i += 2) {
			gc.setAttribute(tag_attrs[i], tag_attrs[i + 1]);
		}

		return gc;
	}


}