/*
 * Copyright (c) 2005 OpenRules, Inc.
 */
package com.openrules.forms.jsp;

import java.io.File;

import com.openrules.forms.IFormsRequest;
import com.openrules.forms.IFormsSession;
import com.openrules.forms.IView;
import com.openrules.forms.gui.IGUIComponent;
import com.openrules.forms.gui.impl.CellLayoutComponent;
import com.openrules.forms.gui.impl.ComponentList;
import com.openrules.forms.gui.impl.GUIComponent;
import com.openrules.forms.gui.impl.RowLayoutComponent;
import com.openrules.forms.gui.impl.TableLayout;
import com.openrules.forms.impl.ApplicationModel;
import com.openrules.forms.impl.ValueAdaptor;
import com.openrules.forms.impl.View;
import com.openrules.forms.xls.LayoutTableNodeBinder;
//import com.openrules.lang.xls.XlsBinder;
//import com.openrules.lang.xls.XlsLoader;
import com.openrules.ruleengine.RuleEngine;
//import com.openrules.ruleengine.XlsRuleEngine;

/* 
 * 7/19/05: JF removed methods inherited from ApplicationModel
 */

public class TestModel1 extends ApplicationModel {

	/**
	 *  
	 */

	public IView updateView(IFormsRequest request, IFormsSession session) {
		View view = new View();

		view.setTopComponent(getTopComponent());
		return view;
	}

	/**
	 * @return
	 */
	private IGUIComponent getTopComponent() {
		GUIComponent form = makeComponent(new String[] { "form", null });

		ComponentList cl = new ComponentList();

				cl.addComponent(tc1());
		//cl.addComponent(tc3("xyz"));

		form.setChildren(cl);
		return form;
	}

	private IGUIComponent tc1() {
		TableLayout tlc = new TableLayout();

		ComponentList cl = new ComponentList();
		cl.addComponent(r1());

		tlc.setChildren(cl);
		return tlc;
	}

	private RowLayoutComponent r1() {
		RowLayoutComponent rlc = new RowLayoutComponent();

		ComponentList cl = new ComponentList();
		cl.addComponent(c11());
		cl.addComponent(c12());

		rlc.setChildren(cl);
		return rlc;
	}

	private CellLayoutComponent c11() {
		CellLayoutComponent clc = new CellLayoutComponent();

		ComponentList cl = new ComponentList();

		cl.addComponent(makeComponent(c11_x));

		clc.setChildren(cl);

		clc.setAttribute("bgcolor", "yellow");

		return clc;
	}

	private CellLayoutComponent c12() {
		CellLayoutComponent clc = new CellLayoutComponent();

		ComponentList cl = new ComponentList();

		cl.addComponent(makeComponent(c12_x));

		clc.setChildren(cl);

		clc.setAttribute("bgcolor", "blue");

		return clc;
	}

	String[] c11_x = { null, "c11" };

	String[] c12_x = { "input", null, "name", "c12" };

	GUIComponent makeComponent(String[] tag_attrs) {
		GUIComponent gc = new GUIComponent();
		gc.setName(tag_attrs[0]);
		if (tag_attrs[1] != null) {
			gc.setDataModelAdaptor(new ValueAdaptor(tag_attrs[1]));
		}

		for (int i = 2; i < tag_attrs.length; i += 2) {
			gc.setAttribute(tag_attrs[i], tag_attrs[i + 1]);
		}

		return gc;
	}

	RuleEngine engine;

	long lastModified = 0;

	/*
	private IGUIComponent tc3(String methodName) {

		String XLS_LAYOUT = "xls.layout";

		XlsLoader.tableHeaders().put("Layout", XLS_LAYOUT);

		XlsBinder.binderFactory().put(XLS_LAYOUT, new LayoutTableNodeBinder());

		String xlsName = "tst/org/openrules/forms/jsp/SimpleLayout2.xls";

		File f = new File(xlsName);

		if (lastModified < f.lastModified()) {
			engine = new XlsRuleEngine(xlsName, methodName);
			lastModified = f.lastModified();
		}

		IGUIComponent gc = (IGUIComponent) engine.run(new Object[0]);

		return gc;
	}
	*/

	String menuitem(String item, String title) {
		return "<a class='navItem' href='index.jsp?action="
				+ item
				+ " title="
				+ title
				+ ">\n"
				+ "<img align=\"absmiddle\" border=\"0\" src=\"img/right_button_out.gif\" onmouseover=\"this.src='img/right_button_on.gif'\" onmouseout=\"this.src='img/right_button_out.gif'\">"
				+ item + "</a>";
	}

	/**
	 *  
	 */


}