/*
 * Copyright (c) 2005-2006 OpenRules, Inc.
 */
package com.openrules.forms.jsp;

import java.io.IOException;
import java.io.InputStream;
import java.util.Vector;

import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
//import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.WorkbookFactory;
import org.apache.poi.poifs.filesystem.POIFSFileSystem;
import org.openl.IOpenSourceCodeModule;
import org.openl.syntax.impl.FileSourceCodeModule;
import org.openl.util.RuntimeExceptionWrapper;

import com.openrules.lang.xls.XlsLoader;
import com.openrules.table.GridSplitter;
import com.openrules.table.IGridTable;
import com.openrules.table.xls.XlsSheetGridModel;

public class XlsSplitter
{

	static public IGridTable[] parse(String xlsName)
	{
		FileSourceCodeModule source = new FileSourceCodeModule(xlsName, null); 

		try
		{
			InputStream is = source.getByteStream(); 
			//POIFSFileSystem fs = new POIFSFileSystem(is);
			Workbook wb = WorkbookFactory.create(is);
			//HSSFWorkbook wb = new HSSFWorkbook(fs);

			int nsheets = wb.getNumberOfSheets();

			Vector vtables = new Vector();

			for (int i = 0; i < nsheets; i++)
			{
				Sheet sheet = wb.getSheetAt(i);
				String sheetName = wb.getSheetName(i);

				IOpenSourceCodeModule sheetSource =
					new XlsLoader.XlsSheetSourceCodeModule(sheetName, source);

				XlsSheetGridModel xlsGrid =
					new XlsSheetGridModel(sheet, sheetName, sheetSource);

				IGridTable[] tables = new GridSplitter(xlsGrid).split();

				for (int j = 0; j < tables.length; j++)
				{
					vtables.add(tables[j]);
				}

			}
		
		return (IGridTable[])vtables.toArray(new IGridTable[0]);	
		}
		catch (Exception e)
		{
			throw RuntimeExceptionWrapper.wrap(e);
		}
	}

}
