/*
 * Copyright (c) 2005-2006 OpenRules, Inc.
 */
package com.openrules.forms;

import java.util.HashMap;

import com.openrules.ruleengine.ExternalRules;

/**
 * 
 * 7/18/05: JF added OpenRulesEngine
 * While we saved the default engine settings, now we assume that a customer 
 * can create an instance of OpenRulesEngine, set its
 * properties like xlsFileName, methodName, businessObjects. Session will run the 
 * currently set engine upon updateView.
 * 
 */
public interface IApplicationModel
{

	IView validateView(IView oldView, IFormsRequest request, IFormsSession session);

	IView updateView(IFormsRequest request, IFormsSession session, Object[] businessObjects);

	/**
	 * @return
	 */
	boolean controlsBodyOnly();

	/**
	 * @param modelURL
	 */
	void restartModel(String modelURL);
	
//	public void setOpenRulesEngine(OpenRulesEngine engine); // JF
//	
//	public OpenRulesEngine getOpenRulesEngine(); // JF
	
	public ExternalRules getExternalRules();
	public void setExternalRules(ExternalRules externalRules);
	
	public HashMap getMap(); // JF
	
	public Class getAppClass(); // JF
	public void setAppClass(Class appClass); // JF

	public String getXlsMain(); // JF
	public void setXlsMain(String xlsMain); 
	
}
