/*
 * Copyright (c) 2005-2006 OpenRules, Inc.
 */
package com.openrules.forms.gui.impl;

import java.util.ArrayList;

import com.openrules.forms.gui.IAttribute;
import com.openrules.forms.gui.IAttributeList;

public class AttributeList extends ArrayList implements IAttributeList
{
	String name, value;

	public AttributeList(){super(3);}
	public AttributeList(int size){super(size);}
	

	public AttributeList(IAttributeList list)
	{
		super(list.getLength());
		int len = list.getLength();
		for (int i = 0; i < len; i++)
		{
			IAttribute attr = list.getAttribute(i);
			add(new Attribute(attr.getName(), attr.getValue()));
		}
	}
	

	/**
	 *
	 */

	public String get(String name)
	{
		int idx = findIndex(name);
		if (idx < 0)
		  return null;
		return getAttribute(idx).getValue();
	}

	/**
	 *
	 */

	public IAttribute getAttribute(int i)
	{
		return (IAttribute) get(i);
	}

	/**
	 *
	 */

	public int getLength()
	{
		return size();
	}

	/**
	 *
	 */

	public int put(String name, String value)
	{
		int idx = findIndex(name);
		if (idx < 0)
			add(new Attribute(name, value));
		else 
		  set(idx, new Attribute(name, value));
		  
		return idx;  	
	}
	
	
	static public class Attribute implements IAttribute
	{
		String name, value;
		
		public Attribute(String name, String value)
		{
			this.name = name;
			this.value = value;
		}
		
		/**
		 * @return
		 */
		public String getName()
		{
			return name;
		}

		/**
		 * @return
		 */
		public String getValue()
		{
			return value;
		}

	}
	
	public int findIndex(String name)
	{
		int size = size();
		for (int i = 0; i < size; i++)
		{
			IAttribute attr = (IAttribute)get(i);
			if (attr.getName().equals(name))
				return i;			
		}
		
		return -1;
	}

	/**
	 *
	 */

	public void putAll(IAttributeList list)
	{
		int len = list.getLength();
		
		for (int i = 0; i < len; i++)
		{
			IAttribute attr = list.getAttribute(i);
			put(attr.getName(), attr.getValue());
		}

	}
	
	
	public static IAttributeList merge(IAttributeList a1, IAttributeList a2)
	{
		if (a1 == null)
		  return a2;
		
		if (a2 == null)
		  return a1;
		  
		AttributeList a = new AttributeList(a1);

		a.putAll(a2);		  
		return a;
		    
	}

}
