/*
 * Copyright (c) 2005-2006 OpenRules, Inc.
 */
package com.openrules.forms.gui.impl;

import com.openrules.forms.gui.IAttributeList;
import com.openrules.forms.gui.IGUIConstants;

public class CellLayoutComponent extends GUIComponent
{

	int colspan = 1, rowspan = 1;
	
	String halign = null;


	/**
	 * @return
	 */
	public int getColspan()
	{
		return colspan;
	}

	/**
	 * @return
	 */
	public int getRowspan()
	{
		return rowspan;
	}


	/**
	 * @param i
	 */
	public void setColspan(int i)
	{
		colspan = i;
	}

	/**
	 * @param i
	 */
	public void setRowspan(int i)
	{
		rowspan = i;
	}

	/**
	 *
	 */

	public String getName()
	{
		return IGUIConstants.CELL_CT;
	}
	
	

	IAttributeList attributes()
	{
		if (attributes == null)
		  attributes = new AttributeList();
		  
		return attributes;  
	}

	/**
	 *
	 */

	public IAttributeList getAttributes()
	{
		
		
		if (rowspan != 1)
			attributes().put(IGUIConstants.ROWSPAN_AT, String.valueOf(rowspan));

		if (colspan != 1)
			attributes().put(IGUIConstants.COLSPAN_AT, String.valueOf(colspan));
			
		if (halign != null)
		  attributes().put(IGUIConstants.ALIGN_AT, halign);	
		
		return attributes;
	}

	/**
	 * @return
	 */
	public String getHalign()
	{
		return halign;
	}

	/**
	 * @param string
	 */
	public void setHalign(String string)
	{
		halign = string;
	}

}
