/*
 * Copyright (c) 2005-2006 OpenRules, Inc.
 */
package com.openrules.forms.gui.impl;

import com.openrules.forms.gui.IDomainAdaptor;

public class DomainAdaptors
{

	static public IDomainAdaptor fromArray(String[] array)
	{
		return new StringArrayDomainAdaptor(array);
	} 
	
	
	static class StringArrayDomainAdaptor implements IDomainAdaptor
	{
		String[] ary;
		
		
		public String getDisplayValue(int i)
		{
			return ary[i];
		}

		/**
		 * @param array
		 */
		public StringArrayDomainAdaptor(String[] array)
		{
			ary = array;			
		}

		public int getLength()
		{
			return ary.length;
		}

		public String getValue(int i)
		{
			return ary[i];
		}

	}

	static class StringArray2DomainAdaptor implements IDomainAdaptor
	{
		String[][] ary;
		
		
		public String getDisplayValue(int i)
		{
			return ary[i][1];
		}

		/**
		 * @param array
		 */
		public StringArray2DomainAdaptor(String[][] array)
		{
			ary = array;			
		}

		public int getLength()
		{
			return ary.length;
		}

		public String getValue(int i)
		{
			return ary[i][0];
		}

	}

	/**
	 * @param strings
	 * @return
	 */
	public static IDomainAdaptor fromArray2(String[][] strings)
	{
		return new StringArray2DomainAdaptor(strings);
	}
}
