/*
 * Copyright (c) 2005-2006 OpenRules, Inc.
 */
package com.openrules.forms.gui.impl;

import com.openrules.forms.gui.IComponentList;
import com.openrules.forms.gui.IDataModelAdaptor;
import com.openrules.forms.gui.IGUIComponent;

public class GUIComponent extends AGUIComponent
{
	
	public GUIComponent()
	{
	}
	

	public GUIComponent(String name)
	{
		this.name = name;
	}

	public GUIComponent(IGUIComponent igc)
	{
		this.name = igc.getName();
		this.children = igc.getChildren();
		this.dataModelAdaptor = igc.getDataModelAdaptor();
		if (igc.getAttributes() != null)
		{
			this.attributes = new AttributeList(igc.getAttributes());
		}
	}
	
	
	String name;
	
	IDataModelAdaptor dataModelAdaptor;
	
	IComponentList children;
	

	/**
	 * @return
	 */
	public IComponentList getChildren()
	{
		return children;
	}

	/**
	 * @return
	 */
	public IDataModelAdaptor getDataModelAdaptor()
	{
		return dataModelAdaptor;
	}

	/**
	 * @return
	 */
	public String getName()
	{
		return name;
	}

	/**
	 * @param components
	 */
	public void setChildren(IComponentList components)
	{
		children = components;
	}

	/**
	 * @param adaptor
	 */
	public void setDataModelAdaptor(IDataModelAdaptor adaptor)
	{
		dataModelAdaptor = adaptor;
	}

	/**
	 * @param string
	 */
	public void setName(String string)
	{
		name = string;
	}
	
	public static GUIComponent makeComponent(String[] tag_attrs)
	{
		GUIComponent gc = new GUIComponent();
		gc.setName(tag_attrs[0]);
//		if (tag_attrs[1] != null)
//		{
//			gc.setDataModelAdaptor(new ValueAdaptor(tag_attrs[1]));
//		}
	
		for (int i = 2; i < tag_attrs.length; i += 2)
		{
			gc.setAttribute(tag_attrs[i], tag_attrs[i + 1]);
		}
	
		return gc;
	}


	static public IGUIComponent merge(IGUIComponent g1, IGUIComponent g2)
	{
		if (g1 == null)
		  return g2;
		if (g2 == null)
		  return g1;  
		
		GUIComponent g = new GUIComponent(g1);
		
		g.setChildren(ComponentList.merge(g1.getChildren(), g2.getChildren()));
		g.setAttributes(AttributeList.merge(g1.getAttributes(), g2.getAttributes()));
		return g;
	}

	

	/**
	 *
	 */

	public String getStringValue()
	{
		return dataModelAdaptor == null ? null : dataModelAdaptor.getValue();
	}
	
	public String toString() {
		return getStringValue();
	}

}
