package com.openrules.forms.gui.impl;

/**
 * @author JF
 */

import java.util.ArrayList;

public class Options extends ArrayList 
{
    private String id;
    
    public Options(String id)
	{
		super(5);
		this.id = id;
	}
    
	public Options(String[] strings) 
	{
		for(int i=0; i < strings.length; i++)
			addOption(new Option(strings[i]));
	}

	public Option getOption(int i)
	{
		return (Option) get(i);
	}

	public int getLength()
	{
		return size();
	}

	public void addOption(Option s)
	{
		add(s);
	}
	
	public void deleteOption(Option s)
	{
		remove(s); 
	}
	
	public void deleteOption(String s)
	{
	    Option o = findOption(s);
		if (o != null )
		    deleteOption(o);
	}
	
	public Option findOption(String s)
	{
		for(int i=0; i<getLength(); i++)
		{
		    Option o = getOption(i);
			if (o.getString().equals(s))
			    return o;
		}
		return null;
	}
	
	public Option checkOption(int i)
	{
		Option o = getOption(i);
		o.check();
		return o;
	}
	public Option uncheckOption(int i)
	{
		Option o = getOption(i);
		o.unCheck();
		return o;
	}
	
	public Option checkOption(String s)
	{
		Option o = findOption(s);
		if (o!=null)
			o.check();
		return o;
	}
	
	public Option uncheckOption(String s)
	{
		Option o = findOption(s);
		if (o!=null)
			o.unCheck();
		return o;
	}
	
	public Options checkedOptions()
	{
		Options checked = new Options("checked");
		for(int i=0; i<getLength(); i++)
		{
		    Option o = getOption(i);
			if (o.isChecked()) {
			    checked.addOption(o);
			}
		}
		return checked;
	}
		
	public void deleteCheckedOptions()
	{
		Options checked = checkedOptions();
		for(int j=0; j<checked.getLength(); j++)
			deleteOption(checked.getOption(j));
	}
	
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }
}
