/*
 * Copyright (C) OpenRules, Inc. 2005-2006
 */
package com.openrules.forms.gui.impl;

import java.util.Iterator;

import com.openrules.data.String2DataConvertorFactory;
import com.openrules.forms.gui.IGUIComponent;
import com.openrules.forms.gui.IGUIConstants;

public class PDFForm implements IGUIConstants
{
  String pdfAppUrl;
  /**
   * @return Returns the buttonMessage.
   */
  public String getButtonMessage()
  {
    return buttonMessage;
  }
  /**
   * @param buttonMessage The buttonMessage to set.
   */
  public void setButtonMessage(String buttonMessage)
  {
    this.buttonMessage = buttonMessage;
  }
  /**
   * @return Returns the pdfAppUrl.
   */
  public String getPdfAppUrl()
  {
    return pdfAppUrl;
  }
  /**
   * @param pdfAppUrl The pdfAppUrl to set.
   */
  public void setPdfAppUrl(String pdfAppUrl)
  {
    this.pdfAppUrl = pdfAppUrl;
  }
  /**
   * @return Returns the pdfFormUrl.
   */
  public String getPdfFormUrl()
  {
    return pdfFormUrl;
  }
  /**
   * @param pdfFormUrl The pdfFormUrl to set.
   */
  public void setPdfFormUrl(String pdfFormUrl)
  {
    this.pdfFormUrl = pdfFormUrl;
  }
  String pdfFormUrl;
  String buttonMessage="Show PDF";
  
  ComponentList fields = new ComponentList(10);
  
  public void addStringField(String fname, String fvalue)
  {
    fields.add(hiddenField("_s." + fname, fvalue));
  }
  
  public void addCheckboxField(String fname, boolean bvalue)
  {
    fields.add(hiddenField("_c." + fname, String.valueOf(bvalue)));
  }

  
  
  GUIComponent hiddenField(String fname, String value)
  {
    GUIComponent gc = new GUIComponent();
    gc.setName(INPUT_CT);
    gc.setAttribute(TYPE_AT, "hidden");
    gc.setAttribute(NAME_AT, fname);
    gc.setAttribute(VALUE_AT, value);
    return gc;
  }
  
  GUIComponent submitButton(String name, String value)
  {
    GUIComponent gc = new GUIComponent();
    gc.setName(INPUT_CT);
    gc.setAttribute(TYPE_AT, "submit");
    gc.setAttribute(NAME_AT, name);
    gc.setAttribute(VALUE_AT, value);
    return gc;
  }
  
  
  public IGUIComponent getForm()
  {
    GUIComponent form = new GUIComponent();
    form.setName("form");
    form.setAttribute("action", this.pdfAppUrl);
    form.setAttribute("method", "post");

    fields.add(hiddenField(PDF_FORM_NAME,this.pdfFormUrl));
    
    fields.add(submitButton("show_pdf",buttonMessage));
    form.setChildren(fields);
   
    return form;
  }
 
  static final public String PDF_FORM_NAME = "pdf_form_name";
  
  
  public String getAsURL()
  {
    StringBuffer buf = new StringBuffer(1000);
    
    buf.append(pdfAppUrl).append('?');
    buf.append(PDF_FORM_NAME).append('=').append(pdfFormUrl);
    
    for (Iterator iter = fields.iterator(); iter.hasNext();)
    {
      GUIComponent element = (GUIComponent) iter.next();
      buf.append('&').append(element.getAttributes().get(NAME_AT)).append('=')
      .append(element.getAttributes().get(VALUE_AT));
      
    }
    
    return buf.toString();
  }
  
  public void put(String name, String value)
  {
    addStringField(name, value);
  }

  
  public void put(String name, int value)
  {
    addStringField(name, String.valueOf(value));
  }

  public void put(String name, double value, String format)
  {
    addStringField(name, String2DataConvertorFactory.getConvertor(double.class).format(new Double(value), format));
  }

  public void put(String name, double value)
  {
    put(name, value, null);
  }
  
  public void put(String name,  boolean value)
  {
    addCheckboxField(name, value);
  }

}
