/*
 * Copyright (c) 2005-2009 OpenRules, Inc.
 */

package com.openrules.forms.gui.jsp;

import java.util.HashMap;

public class DialogComponent {

	Dialog dialog;
	String id;
	String name;
	boolean hidden;
	HashMap properties;
	
	public DialogComponent(Dialog d) {
		this(d,"?");
	}
	
	public DialogComponent(Dialog d, String id) {
		this(d,id,id);
	}
	
	
	public DialogComponent(Dialog d, String id, String name) {
		this.dialog = d;
		this.id = id;
		this.name = name;
		hidden = false;
		properties = new HashMap();
	}
	
	public final HashMap getProperties() {
		return properties;
	}
	
	public final boolean hasProperties() {
		return properties.size() > 0;
	}

	public void addProperty(String key, String value) {
		properties.put(key, value);
	}
	
	public String getProperty(String key) {
		return (String) properties.get(key);
	}
	
	public final Dialog getDialog() {
		return dialog;
	}

	public void setDialog(Dialog dialog) {
		this.dialog = dialog;
	}

	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}

	public final boolean isHidden() {
		return hidden;
	}

	public void setHidden(boolean hidden) {
		this.hidden = hidden;
	}
	
	

}
