/*
 * Copyright (c) 2005-2009 OpenRules, Inc.
 */
package com.openrules.forms.gui.jsp;

import java.util.Iterator;
import java.util.Vector;

import com.openrules.forms.gui.impl.TableLayout;

public class Section extends DialogComponent {
	Vector questions;
	TableLayout layout;

	public Section(Dialog d, String id, String name) {
		super(d, id, name);
		questions = new Vector();
	}

	public Vector getQuestions() {
		return questions;
	}

	public void setQuestions(Vector questions) {
		this.questions = questions;
	}

	public void addQuestion(Question question) {
		//ORDLicense.addQuestion(question,questions);
		questions.add(question);
	}

	public Question getQuestion(String id) {
		Iterator it = questions.iterator();
		while (it.hasNext()) {
			Question question = (Question) it.next();
			if (question.getId().equals(id))
				return question;
		}
		return null; 
	}
	
	public void resetAllQuestions() {
		Iterator it = questions.iterator();
		while (it.hasNext()) {
			Question question = (Question) it.next();
			question.resetDefaultAnswer();
		}		
	}

	public TableLayout getLayout() {
		return layout;
	}

	public void setLayout(TableLayout layout) {
		this.layout = layout;
	}

	public void addLayout(TableLayout questionLayout) {
		if (layout != null)
			layout = TableLayout.merge(layout, questionLayout);
		else
			layout = questionLayout;
	}

}
