/*
 * Copyright (c) 2005-2006 OpenRules, Inc.
 */
package com.openrules.forms.impl;

import com.openrules.forms.IApplicationModel;
import com.openrules.forms.IFormsSession;
import com.openrules.ruleengine.ExternalRules;

/**
 * 10/07/2005L JF added IDialog 
 * 
 * 08/15/2006: JF added path tp xlsMain file to constructors
 * 
 */

public class FormsSession implements IFormsSession
{
	
	public static final String APP_MODEL = "com.openrules.forms.applicationmodel";
	
//	public FormsSession()
//	{
//		initialize(null);
//	}
	
	public FormsSession(String xlsMain, Class appClass, ExternalRules externalRules)
	{
		initialize(appClass,externalRules);
		applicationModel.setXlsMain(xlsMain);
		applicationModel.setExternalRules(externalRules);
	}
	
	static final public String DEFAULT_APPLICATION_MODEL = DefaultApplicationModel.class.getName();

	/**
	 * 
	 */
	protected void initialize(Class appClass,ExternalRules externalRules)
	{
		String className = System.getProperty(APP_MODEL);
		
		if (className == null)
		{
//			applicationModel = new ErrorApplicationModel("System variable " + APP_MODEL + " is not set");
//			return;
			className = DEFAULT_APPLICATION_MODEL;
		}
		
		Class appModelClass = null;
		try
		{
			appModelClass = Class.forName(className);				
		}
		catch (Exception e)
		{
			applicationModel = new ErrorApplicationModel("Class not found: " + className);
			return;
		}
		
		try
		{
			applicationModel = (IApplicationModel)appModelClass.newInstance();
			//applicationModel.setXlsMain(xlsMain);
			if (appClass!=null)
				applicationModel.setAppClass(appClass);
		}
		catch (Exception ex)
		{
			applicationModel = new ErrorApplicationModel("Error initializing application model: " + ex.getMessage());
			return;
		}
		
	}

	
	IApplicationModel applicationModel;


	/**
	 * @return
	 */
	public IApplicationModel getApplicationModel()
	{
		return applicationModel;
	}

	/**
	 * @return
	 */
	public boolean controlsBodyOnly()
	{
		return applicationModel.controlsBodyOnly();
	}
	
	public void restartModel(String modelURL)
	{
		applicationModel.restartModel(modelURL);
	}

}
