/*
 * Copyright (C) 2004-2006 OpenRules, Inc.
 */


package com.openrules.forms.xls;

import org.openl.IOpenSourceCodeModule;
import org.openl.OpenL;
import org.openl.OpenlTool;
import org.openl.binding.IBindingContext;
import org.openl.binding.IBindingContextDelegator;
import org.openl.binding.IMemberBoundNode;
import org.openl.syntax.ISyntaxNode;
import org.openl.syntax.impl.SubTextSourceCodeModule;
import org.openl.types.IOpenMethodHeader;
import com.openrules.lang.xls.IXlsTableNames;
import com.openrules.lang.xls.binding.AXlsTableBinder;
import com.openrules.lang.xls.binding.XlsModuleOpenClass;
import com.openrules.lang.xls.syntax.XlsTableSyntaxNode;

import com.openrules.table.IGridTable;
import com.openrules.table.openl.GridCellSourceCodeModule;

public class LayoutTableNodeBinder extends AXlsTableBinder implements IXlsTableNames
{

	/* (non-Javadoc)
	 * @see com.openrules.lang.xls.binding.AXlsTableBinder#preBind(org.openl.syntax.ISyntaxNode, org.openl.OpenL, org.openl.binding.IBindingContext)
	 */
	public IMemberBoundNode preBind(
		ISyntaxNode syntaxNode,
		OpenL openl,
		IBindingContext cxt,
		XlsModuleOpenClass module)
	{

		XlsTableSyntaxNode methodNode =
			(XlsTableSyntaxNode) syntaxNode;

		IGridTable table = methodNode.getTable();


    IOpenSourceCodeModule src = new GridCellSourceCodeModule(table);


		IOpenMethodHeader header = OpenlTool.getMethodHeader(new SubTextSourceCodeModule(src, methodNode.getHeader().length()), openl, (IBindingContextDelegator)cxt);

		return new LayoutTableBoundNode(methodNode, openl, header, module);
	}

}
