/*
 * Copyright (c) 2005 OpenRules, Inc.
 */
package com.openrules.forms.xls;

import org.openl.IOpenSourceCodeModule;
import org.openl.OpenlToolAdaptor;
import org.openl.types.IOpenMethod;
import org.openl.vm.IRuntimeEnv;

import com.openrules.forms.gui.IGUIComponent;
import com.openrules.forms.gui.impl.AttributeList;
import com.openrules.forms.gui.impl.GUIComponent;
import com.openrules.forms.impl.ValueAdaptor;

class MethodCellBuilder implements ICellGUIComponentBuilder
{

	IOpenMethod method;
	AttributeListHolder attrs;

	/**
	*
	*/

	public IGUIComponent buildComponent(
		Object target,
		Object[] params,
		IRuntimeEnv env)
	{
		Object res = method.invoke(target, params, env);

		if (res instanceof IGUIComponent)
		{
			IGUIComponent gc = (IGUIComponent) res;
			
			
			gc.setAttributes(AttributeList.merge(gc.getAttributes(),attrs == null ? null :   attrs.makeAttributes(target, params, env)));
			
			return gc;
		}

		if (res == null)
		  res="";
		GUIComponent gc = new GUIComponent();
		gc.setDataModelAdaptor(new ValueAdaptor(String.valueOf(res)));
		return gc;

	}

	static public MethodCellBuilder makeMethodBuilder(
		IOpenSourceCodeModule src,
		OpenlToolAdaptor op, AttributeListHolder attrs)
	{

//TODO think about attrs

		MethodCellBuilder cmb = new MethodCellBuilder();
		IOpenMethod method = op.makeMethod(src);
		cmb.method = method;

		return cmb;
	}

}