/*
 * Copyright (c) 2005 OpenRules, Inc.
 */
package com.openrules.forms.xls;

import com.openrules.forms.gui.IAttributeList;
import com.openrules.forms.gui.IComponentList;
import com.openrules.forms.gui.IDataModelAdaptor;
import com.openrules.forms.gui.IGUIComponent;
import com.openrules.forms.gui.impl.AttributeList;
import com.openrules.forms.gui.impl.ComponentList;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class NodeGUIComponent implements IGUIComponent
{
	Node node;

	IDataModelAdaptor adaptor;
	
	public NodeGUIComponent(Node node)
	{
		this.node = node;
	}
	
	
	IAttributeList attributes;
	
	/**
	 *
	 */

	public IAttributeList getAttributes()
	{
		if (attributes == null)
			attributes = makeAttributes(node);
		
		return attributes;			
	}


	static public IAttributeList makeAttributes(Node node)
	{
		NamedNodeMap nnmap = node.getAttributes();
		if (nnmap == null)
		  return null;
		
		AttributeList list = new AttributeList();
		
		for (int i = 0; i < nnmap.getLength(); i++)
		{
			Node n = nnmap.item(i);
			list.put(n.getNodeName(), n.getNodeValue());
		}
		
		return list;
	}




	/**
	 *
	 */

	public IDataModelAdaptor getDataModelAdaptor()
	{
		return adaptor;
	}


	/**
	 *
	 */

	public String getName()
	{
		
		if (node.getNodeType() == Node.ELEMENT_NODE)
				return node.getNodeName();

		return null;		
	}

	/**
	 *
	 */

	public void setAttribute(String name, String value)
	{
		throw new UnsupportedOperationException();
	}

	/**
	 *
	 */

	public IComponentList getChildren()
	{
		ComponentList cl = new ComponentList();
		
		NodeList nl = node.getChildNodes();
		
		int len = nl.getLength();
		
		for (int i = 0; i < len; i++)
		{
			cl.addComponent(new NodeGUIComponent(nl.item(i)));
		}
		
		return cl;
	}

	/**
	 *
	 */

	public String getStringValue()
	{
		if (node.getNodeType() == Node.ELEMENT_NODE)
			return null;
		return node.getNodeValue();


	}

	/**
	 * @param list
	 */
	public void setAttributes(IAttributeList list)
	{
		attributes = list;
	}

}
