package com.openrules.java.ant;

/*
 * Copyright (C) 2006 OpenRules, Inc.
 * 
 */

import java.text.MessageFormat;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

public class Messages {
	private static final String BUNDLE_NAME = "com.openrules.java.ant.messages"; //$NON-NLS-1$

	private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle
			.getBundle(BUNDLE_NAME);

	private Messages() {
	}

	public static String getString(String key) {
		try {
			return RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}
	public static String getString(String key, Object param) {
		return getString(key, new Object[] { param } );
	}
	
	public static String getString(String key, Object param1, Object param2 ) {
		return getString(key, new Object[] { param1, param2 } );
	}

	public static String getString(String key, Object[] params) {
		String format = null;
		try {
			format = RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
		return MessageFormat.format( format, params );
	}
}
