package com.openrules.java;

import junit.framework.TestCase;

import org.openl.OpenL;
import org.openl.conf.ConfigurableResourceContext;
import org.openl.syntax.impl.StringSourceCodeModule;

public class OpenLBuilderTest extends TestCase {
	
	public void testBuilder() {
		JavaOpenLBuilder builder = new JavaOpenLBuilder();
		builder.setConfigurableResourceContext( new ConfigurableResourceContext(null), null);

		OpenL openl = builder.build(null);
		assertNotNull( openl );
		
		String code = "String s = \"mama\"; System.out.println(s);";
		code += "int hour = Calendar.getInstance().get(Calendar.HOUR_OF_DAY);";
		code += "System.out.println(hour);";
		code += "File f = new File(\".\");";
		code += "System.out.println(f.getAbsolutePath());";
		code += "Response r = new Response();r.result= \"XXX\";";
		code += "System.out.println(\"Response:\"+r.result);";
		code += "Customer customer = Customer.load(\"classpath:/my/Customer.xml\");";
		code += "System.out.println(\"Customer: \"+customer.name);";
		
		//Integer result = (Integer) openl.evaluate(new StringSourceCodeModule( "1 + 1", null));
		// assertEquals( 2, result.intValue() );
		openl.evaluate(new StringSourceCodeModule( code, null));

	}
}
