package hello;

import java.util.Date;
import java.util.GregorianCalendar;

public class DateDiff {
	
	public static long years(Date d1, Date d2) { 
		long milliseconds1 = d1.getTime();
		long milliseconds2 = d2.getTime();
		long diff = milliseconds2 - milliseconds1;
		long diffSeconds = diff / 1000;
		long diffMinutes = diffSeconds / 60;
		long diffHours = diffMinutes / 60;
		long diffDays = diffHours / 24;
		long diffYears = (long)(Math.floor(diffDays / 365));
		return diffYears;
	}
	
	public static long yearsToday(Date d1) {
		return years(d1,new Date());
	}
	
	public static long days(Date d1, Date d2) { 
		long milliseconds1 = d1.getTime();
		long milliseconds2 = d2.getTime();
		long diff = milliseconds2 - milliseconds1;
		long diffSeconds = diff / 1000;
		long diffMinutes = diffSeconds / 60;
		long diffHours = diffMinutes / 60;
		long diffDays = diffHours / 24;
		//long diffYears = (long)(Math.floor(diffDays / 365));
		return diffDays;
	}
	
	public static long daysToday(Date d1) { 
		return days(d1,new Date());
	}
	
	public static long months(Date d1, Date d2) { 
		int diffYear = d1.get(Calendar.YEAR) - d2.get(Calendar.YEAR);
		int diffMonth = diffYear * 12 + endCalendar.get(Calendar.MONTH) - startCalendar.get(Calendar.MONTH);

		return (long)(Math.floor(days(d1,d2)/30));
	}
	
	public static long monthsToday(Date d1) {
		return months(d1,new Date());
	}
	
	public static void main(String[] args) {
		/** The date at the end of 1980 */
		Date d1 = new GregorianCalendar(1979, 11, 31, 23, 59).getTime();

		/** Today's date */
		Date d2 = new Date();
		
		System.out.println("Years since " + d1 +": " + DateDiff.years(d1,d2));
		
		Date d3 = new GregorianCalendar(2014, 11, 31, 23, 59).getTime();
		System.out.println("Days between " + d2 +" and " + d3 + ": " + DateDiff.days(d2,d3));
		
/*
2/1/2018              12/31/2018                                         11
2/1/2018              11/30/2018                                         10
2/1/2018              10/30/2018                                         9
2/1/2018              9/30/2018                                            8
*/
		Date d4 = new GregorianCalendar(2018, 11, 31, 23, 59).getTime();
		Date d5 = new GregorianCalendar(2018, 02, 01, 23, 59).getTime();
		System.out.println("Months between " + d4 +" and " + d5 + ": " + DateDiff.months(d4,d5));

	}

}
