package com.openrules.feel;

import com.openrules.ruleengine.Glossary;

public class OpenRulesContext extends Context {
	
	Glossary glossary;

	public OpenRulesContext(Glossary glossary) {
		this.glossary = glossary;
	}

	@Override
	public double getDoubleValue(String variableName) {
		try {
			return glossary.getReal(variableName);
		} catch (Exception e) {
			try {
				return glossary.getInt(variableName);
			} catch (Exception e2) {
				try {
					return glossary.getLong(variableName);
				} catch (Exception e3) {
					throw new RuntimeException("Cannot find variable: " + variableName );
				}
			}
		}
	}

	public Glossary getGlossary() {
		return glossary;
	}
	
}
