package com.openrules.feel;

import org.openl.util.Log;

import com.openrules.ruleengine.Decision;
import com.openrules.ruleengine.Glossary;

public class OpenRulesFeelEvaluator extends BasicFeelEvaluator {
	
	Glossary glossary;
	
	public OpenRulesFeelEvaluator(Glossary glossary) {
		super(new OpenRulesContext(glossary));
		this.glossary = glossary;
		
		Decision decision = glossary.getDecision();
		getContext().setLongNameIndicator(decision.getLongNameIndicator());
	}	
	
	/**
	 * This method is used to log warnings and errors found during FEEL expression evaluations
	 * @param text
	 */
	public void log(String text) {
		//glossary.getDecision().log("FEEL: "+text);
		//System.err.println("FEEL: "+text);
		Log.debug("FEEL: "+text);
	}
}
