/**
 * (c) OpenRules, Inc. 2017
 */

package com.openrules.ruleengine;

import java.util.ArrayList;

import com.openrules.dt.ProxyDecisionTable;

public class DT {
	String id;
	ProxyDecisionTable decisionTable;
    ArrayList<String> inputVariables; 
    ArrayList<String> outputVariables; 
	ArrayList<DT> requiredDTs;
    
    
    public DT(String id, ProxyDecisionTable decisionTable) {
    	this.id = id;
    	this.decisionTable = decisionTable;
    	inputVariables = new ArrayList<String>();
    	outputVariables = new ArrayList<String>();
    	requiredDTs = new ArrayList<DT>();
    }
    
    public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}
	
	public ProxyDecisionTable getDecisionTable() {
		return decisionTable;
	}

	public void addInputVariable(String variable) {
    	inputVariables.add(variable);
    }
    
    public void addOutputVariable(String variable) {
    	outputVariables.add(variable);
    }
    
    public void addRequiredDT(DT dt) {
    	requiredDTs.add(dt);
    }
    
     
//	public String[] getTableLabels() {
//    	int numberOfColumns = inputVariables.size() + outputVariables.size();
//    	String[] labels = new String[numberOfColumns];
//	    
//	    int n = 0;
//	    for (int i = 0; i < inputVariables.size(); i++) {
//	    	labels[n++] = "If";
//	    	//labels[n++] = "Condition";
//		}
//	    for (int i = 0; i < outputVariables.size(); i++) {
//	    	//labels[n++] = "Action";
//	    	labels[n++] = "Conclusion";
//		}
//    	return labels;
//    }
    
    public String[] getTableVariables() {
    	int numberOfColumns = inputVariables.size() + outputVariables.size();
    	String[] variables = new String[numberOfColumns];
	    
	    int n = 0;
	    for (int i = 0; i < inputVariables.size(); i++) {
	    	variables[n++] = inputVariables.get(i);
		}
	    for (int i = 0; i < outputVariables.size(); i++) {
	    	variables[n++] = outputVariables.get(i);
		}
    	return variables;
    }

	@Override
	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append("\nDT: " + id 
				+ "\n\toutputVariables=" + outputVariables 
				+ "\n\trequiredDTs:");
		for (int i = 0; i < requiredDTs.size(); i++) {
			buf.append(" "+requiredDTs.get(i).getId());
		}
		return buf.toString();	
	}
    
//    public String[][] getTableEntries() {
//    	//int numberOfColumns = inputVariables.size() + outputVariables.size();
//    	int numberOfColumns = inputVariables.size() + outputVariables.size()*2;
//    	//int numberOfColumns = inputVariables.size()*2 + outputVariables.size();
//    	String conclusionOper = "Is";
//    	if ("Sum".equalsIgnoreCase(aggregation))
//    		conclusionOper = "+=";
//	    String[][] entries = new String[rules.size()][numberOfColumns]; 
//	    for (int r = 0; r < rules.size(); r++) {
//	    	Rule rule = rules.get(r);
//	    	int column = 0;
//		    for (int i = 0; i < rule.inputEntries.size(); i++) {
//		    	String entry = rule.inputEntries.get(i);
//		    	//entries[r][column++] = "Is"; // added for Condition instead of If
//				entries[r][column++] = entry;
//			}
//		    for (int i = 0; i < rule.outputEntries.size(); i++) {
//		    	String entry = rule.outputEntries.get(i);
//		    	entries[r][column++] = conclusionOper;
//		    	entries[r][column++] = entry;
//			}
//			
//		}
//	    return entries;
//    }
    
    
}
