package com.openrules.ruleengine;

import java.util.HashMap;

//
// This is an interface for decision objects generated for
// the BusinessMap decision interface
//

public interface DecisionObject {
	/**
	 * @return a HashMap with attribute pairs <name,type>
	 */
	public HashMap<String,String> getAttributes();
	
	/**
	 * Sets a value "value" for the attribute "name"
	 * @param name
	 * @param value
	 */
	public void setAttribute(String name, String value);
	
	/**
	 * @param name
	 * @return a String value of the attribute "name"
	 */
	public String getAttribute(String name);
}
