package com.openrules.ruleengine;

import com.openrules.types.DataMap;

//import com.openrules.ruleengine.Glossary;

public class GlossaryElement {
	Glossary glossary;
	Object property;
	String businessConcept;
	//Object object;
	String attribute;
	String usedAs;
	String value;
	String domain;
	String type;
	boolean unknown;
	boolean dynamic;
	
	
	public GlossaryElement(Glossary glossary) {
		this.glossary = glossary;
		unknown = true; // default for Rule Solver
	}
	
	public final String getBusinessConcept() {
		return businessConcept;
	}
	public final void setBusinessConcept(String businessConcept) {
		this.businessConcept = businessConcept;
	}
	public final Object getProperty() {
		return property;
	}
	public final void setProperty(Object property) {
		this.property = property;
	}
	public final String getType() {
		return type;
	}
	public final void setType(String type) {
		this.type = type;
	}
	public final boolean isDynamic() {
		return dynamic;
	}
	public final void setDynamic(boolean dynamic) {
		this.dynamic = dynamic;
	}
	public final Object getBusinessObject() {
		return glossary.getBusinessObject(businessConcept);
	}

	public final String getAttribute() {
		return attribute;
	}

	public final void setAttribute(String attribute) {
		this.attribute = attribute;
	}
	
	public final String getDomain() {
		return domain;
	}
	public final void setDomain(String domain) {
		this.domain = domain;
	}
	
	public String getUsedAs() {
		return usedAs;
	}

	public void setUsedAs(String usedAs) {
		this.usedAs = usedAs;
	}

	public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}

	public final boolean isUnknown() {
		return unknown;
	}
	public final void setUnknown(boolean unknown) {
		this.unknown = unknown;
	}
	
	public final String toString() {
		if (type.equals(DataMap.TYPE_UNDEFINED)) // when value is unknown
				return attribute + " TYPE_UNDEFINED";
		return attribute; // + " = " + glossary.resolveValue(attribute);
	}
}
