package com.openrules.ruleengine;

public class Goal {
	
	DecisionModel 	decisionModel;
	String 			name;	
	Decision 		decision;

	public Goal(String name, DecisionModel decisionModel) {
		this.decisionModel = decisionModel;
		this.name = name;
		decision = decisionModel.createDecision(name);
	}
	
	public String getName() {
        return name;
    }

    public void use(String businessConcept, Object object) {
		decision.put(businessConcept, object);
		decision.putObject(businessConcept, object);
	}
	
	public Decision getDecision() {
	    return decision;
	}
	
	public void put(String key, Object object) {
	    decision.put(key, object);
	}
	
	public Object get(String key) {
        return decision.get(key);
    }
	
	public Object execute() {
		return decision.execute();
	}
	
	public boolean test(String decisionTests) {
        return decision.test(decisionTests);
    }
    
    public boolean test() {
        return test("testCases");
    }
    
    public boolean test(int numberOfTestsToBeExecuted) {
        return decision.test("testCases",numberOfTestsToBeExecuted); 
    }
	
	public void saveRunLog(boolean truefalse) {
	    decision.saveRunLog(truefalse);
	}
	
	public void printSavedRunLog(String filename) {
	    decision.printSavedRunLog(filename);
	}
	
	public void log(String text) {
		decision.log(text);
	}

}
