package com.openrules.feel;

public class TestEvaluator extends BasicFeelEvaluator {
	
	public TestEvaluator() {
		super(new TestContext());
	}
	
	public static void main(String[] args) {
		
		FeelEvaluator evaluator = new TestEvaluator();
		
		// TEST 1
		String  feelExpression1 = "(CustomerAge > 18)*(-1)";
		boolean result1 = evaluator.evaluateAsBoolean(feelExpression1);
		System.out.println("Expression '" + feelExpression1 + "' evaluated as " + result1);
		// TEST2
		String  feelExpression2 = "((Monthly Income*3 - Monthly Debt*3)/3 * Loan Term) * 0.8";
		double result2 = evaluator.evaluateAsDouble(feelExpression2,false);
		System.out.println("Expression '" + feelExpression2 + "' evaluated as " + result2);
				
		// TEST 3
		String  feelExpression3 = "CustomerAge <> 25";
		boolean result3 = evaluator.evaluateAsBoolean(feelExpression3,false);
		System.out.println("Expression '" + feelExpression3 + "' evaluated as " + result3);
		
		// TEST 4
		try {
			String  feelExpression4 = "CustomerAge > 15 or CustomerAge < 30";
			boolean result4 = evaluator.evaluateAsBoolean(feelExpression4,false);
			System.out.println("Expression '" + feelExpression4 + "' evaluated as " + result4);
			
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
		
		
		// TEST 5
		String  feelExpression5 = "(CustomerAge-21)**2";
		int result5 = evaluator.evaluateAsInt(feelExpression5,false);
		System.out.println("Expression '" + feelExpression5 + "' evaluated as " + result5);
		
		// TEST 6
		String  feelExpression6 = "max(Monthly Income,Monthly Debt)";
		int result6 = evaluator.evaluateAsInt(feelExpression6,false);
		System.out.println("Expression '" + feelExpression6 + "' evaluated as " + result6);
		
		// TEST 7
		String  feelExpression7 = "CustomerAge != 25";
		boolean result7 = evaluator.evaluateAsBoolean(feelExpression7,false);
		System.out.println("Expression '" + feelExpression7 + "' evaluated as " + result7);
		
		// TEST8
		String  feelExpression8 = "Monthly Income < Monthly Debt * Loan Term";
		double result8 = evaluator.evaluateAsDouble(feelExpression8,false);
		System.out.println("Expression '" + feelExpression8 + "' evaluated as " + result8);
		
		// TEST9
		String  feelExpression9 = "'Monthly Income' < 'Monthly Debt' * 'Loan Term'";
		double result9 = evaluator.evaluateAsDouble(feelExpression9,false);
		System.out.println("Expression '" + feelExpression9 + "' evaluated as " + result9);
		
		// TEST10
		String  feelExpression10 = "'Patient's Weight' < 200";
		double result10 = evaluator.evaluateAsDouble(feelExpression10,false);
		System.out.println("Expression '" + feelExpression10 + "' evaluated as " + result10);
		
		// TEST11
		evaluator.getContext().setLongNameIndicator('$');
		String  feelExpression11 = "$Patient's Weight$ <= 200";
		double result11 = evaluator.evaluateAsDouble(feelExpression11,false);
		System.out.println("Expression '" + feelExpression11 + "' evaluated as " + result11);
		
		// TEST111
		evaluator.getContext().setLongNameIndicator('\'');
		String  feelExpression111 = "'Patient''s Weight' <= 200";
		double result111 = evaluator.evaluateAsDouble(feelExpression111,false);
		System.out.println("Expression '" + feelExpression111 + "' evaluated as " + result111);
		
		// TEST 12
		evaluator.getContext().setLongNameIndicator('\'');
		String  feelExpression12 = "'Patient-Age' != 25";
		boolean result12 = evaluator.evaluateAsBoolean(feelExpression12,false);
		System.out.println("Expression '" + feelExpression12 + "' evaluated as " + result12);
		
		// TEST 13
		//String  feelExpression13 = "35 > (Total Amount/Total Assets)*100";
		String  feelExpression13 = "Total Amount > Total Assets*0.30";
		boolean result13 = evaluator.evaluateAsBoolean(feelExpression13,false);
		System.out.println("Expression '" + feelExpression13 + "' evaluated as " + result13);
		
	}
}
