/*
 * Created on Oct 8, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */

package com.openrules.dt;

import java.util.ArrayList;
import java.util.List;
//import java.util.Vector;

import org.openl.OpenL;
import org.openl.binding.IBindingContextDelegator;
import org.openl.binding.impl.module.ModuleOpenClass;
import org.openl.util.Log;

import com.openrules.lang.xls.IXlsTableNames;
import com.openrules.table.ILogicalTable;

/**
 * @author snshor modified by IK
 * 
 */
public class DTLoader implements IDecisionTableConstants {

	protected int columns;
	protected List functionRows = new ArrayList();

	private void loadRow(int row, ILogicalTable table) throws Exception {
		FunctionalRow fr = FunctionalRow.make(row, table);
		if (fr != null)
			functionRows.add(fr);
	}


	public DecisionTable load(ILogicalTable table, DecisionTable dt,
			OpenL openl, ModuleOpenClass module, IBindingContextDelegator cxtd)
			throws Exception {

		ILogicalTable tableBody = table.rows(1);

		//Make sure that a rule table created based on a template follows its direction
		
		String direction = dt.getDirection();
		if (dt.getDirection().equals(IXlsTableNames.DIRECTION_UNKNOWN)) {
		    direction = DirectionHelper.directionOf(tableBody);
			dt.setDirection(direction);
		}
				
		if (direction.equals(IXlsTableNames.DIRECTION_VERTICAL)) {
			Log.debug("Decision table " + dt.getName() + " is recognized as Vertical " + Log.timestamp());
			tableBody = tableBody.transpose();
		}
		else {
			Log.info("Decision table " + dt.getName() + " is recognized as Horizontal " + Log.timestamp());
		}

		if (tableBody.getLogicalWidth() < DATA_COLUMN)
			throw new Exception("Invalid structure of decision table");

		columns = tableBody.getLogicalWidth() - DATA_COLUMN;

		for (int i = 0; i < tableBody.getLogicalHeight(); i++) {
			loadRow(i, tableBody);
		}

		dt.bindTable(tableBody, (IDecisionRow[]) functionRows
				.toArray(new IDecisionRow[0]), openl, module, cxtd, columns);

		return dt;
	}

}