package com.openrules.dt;

import com.openrules.lang.xls.IXlsTableNames;
import com.openrules.table.ILogicalTable;

public class DirectionHelper {

//	private static boolean looksLikeTransposed(ILogicalTable table) {
//
//		int cnt1 = countConditionsAndActions(table);
//		int cnt2 = countConditionsAndActions(table.transpose());
//
//		if (cnt1 != cnt2)
//			return cnt1 > cnt2;
//		return table.getLogicalWidth() <= IDecisionTableConstants.DATA_COLUMN;
//	}

	private static int[] failedDimensions(ILogicalTable table) {
		return new int[] { notConditionsAndActions(table), notConditionsAndActions(table.transpose()) };
	}

	// calculates how many columns failed to be recognized as functions
	private static int notConditionsAndActions(ILogicalTable t) {
		int width = t.getLogicalWidth();
		int cnt = 0;
		for (int i = 0; i < width; i++) {
			String label = t.getLogicalColumn(i).getGridTable().getStringValue(0, 0);
			boolean isFunctionLabel = IDecisionRowMetaInfo.Helper.isFunctionLabel(label);
			if (i > 0 && !isFunctionLabel)
				break;
			cnt += isFunctionLabel ? 1 : 0;
		}
		return width - cnt;
	}

	public static String directionOf(ILogicalTable tableBody) {

		int[] fdims = failedDimensions(tableBody);

		boolean looksLikeTransposed = fdims[0] == 0;

		if (looksLikeTransposed)
			return IXlsTableNames.DIRECTION_VERTICAL;
		else
			return IXlsTableNames.DIRECTION_HORIZONTAL;
	}

	public static String directionOf(ILogicalTable tableBody, DecisionTable base) {

		int[] fdims = failedDimensions(tableBody);

		if (fdims[0] == 0 || fdims[1] == 0) {
			boolean looksLikeTransposed = fdims[0] == 0;
			if (looksLikeTransposed)
				return IXlsTableNames.DIRECTION_VERTICAL;
			else
				return IXlsTableNames.DIRECTION_HORIZONTAL;
		}
		
		//no functions row found
		
		// check matching dimensions
		int requiredFunctions = 0;
		for( IDecisionRow row : base.getFunctionRows() ) {
			if ( !row.getMetaInfo().isOptional() ) {
				requiredFunctions += 1;
			}
		}
		if ( tableBody.getLogicalWidth() != tableBody.getLogicalHeight() ) {
			if ( tableBody.getLogicalHeight() == requiredFunctions ) {
				return IXlsTableNames.DIRECTION_VERTICAL;
			} else if ( tableBody.getLogicalWidth() == requiredFunctions ) {
				return IXlsTableNames.DIRECTION_HORIZONTAL;
			}
		}
		
		//otherwise the same as parent
		return base.getDirection();
	}

}
