/*
 * Created on Nov 7, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */

package com.openrules.dt;

import org.openl.OpenL;
import org.openl.binding.IBindingContextDelegator;
import org.openl.binding.impl.module.ModuleOpenClass;
import org.openl.types.IMethodSignature;
import org.openl.types.IOpenClass;
import org.openl.vm.IRuntimeEnv;

/*
 * @author snshor
 *
 * May-2007: JF replaced return type void to Object for executeAction()
 * Nov-2012: JF added getColumnValue(int col) for reporting purposes
 *
 */
public interface IDecisionRow {

	public IDecisionRowMetaInfo getMetaInfo();

	public void prepare(
		IOpenClass methodType,
		IMethodSignature signature,
		OpenL openl,
		IOpenClass dtModule,
		IBindingContextDelegator cxtd) throws Exception;

	IDecisionValue calculateCondition(
		int col,
		Object target,
		Object[] dtParams,
		IRuntimeEnv env);


	Object executeAction(
		int col,
		Object target,
		Object[] dtParams,
		IRuntimeEnv env);
	
	public String getColumnValue(int col); // JF
	public String getColumnSource(int col, int paramCol); // JF

}
