/*
 * Created on Sep 10, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */

package com.openrules.dt;

import org.openl.OpenL;
import org.openl.binding.IBindingContextDelegator;
import org.openl.types.IOpenClass;
import org.openl.types.IOpenMethod;

import com.openrules.table.ILogicalTable;
import com.openrules.types.IDecision;

/**
 * @author snshor
 * 
 */
public interface IDecisionTable extends IOpenMethod {
	
	void bindTable(ILogicalTable table, IDecisionRow[] functionRows, OpenL openl,
			IOpenClass module, IBindingContextDelegator cxtd, int columns)
			throws Exception;

	IInvocationStrategy getInvocationStrategy();

	//all functions in order they appear in function row table
	IDecisionRow[] getFunctionRows();
	
	//only condition functions
	IDecisionRow[] getConditions();
	
	//only action functions
	IDecisionRow[] getActions();
	
	int getColumns();
	
	boolean isCalculateConditionsFirst();

	void setCalculateConditionsFirst(boolean calculateConditionsFirst);
	
	public String getDirection();
	
	public void setDirection(String direction);
	
	public IDecision getDecision();
	
	public void setDecision(IDecision decision);
	
}
