/*
 * Created on Oct 2, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 * 
 * Modified on 8/26/2005; JF changed SEARCH_FILE_NAME = "com/openrules/com.openrules.properties"
 * to keep ALL com.openrules properties in one file
 * 
 */

package com.openrules.lang.xls;

import org.openl.IOpenParser;
import org.openl.IOpenSourceCodeModule;
import org.openl.conf.ConfigurableResourceContext;
import org.openl.conf.IConfigurableResourceContext;
import org.openl.conf.IUserContext;
import org.openl.syntax.IParsedCode;

/**
 * @author snshor
 * 
 * JF: redefined SEARCH_FILE_NAME Modified by IK on 08/12/2006 to support for
 * imports directly from xls Environment tables. Saves IUserContext
 * 
 */
public class XlsParser implements IOpenParser {

	IUserContext ucxt; // IK
	IConfigurableResourceContext cxt;

	/**
	 * @param ucxt
	 * @param gf
	 */
	public XlsParser(IUserContext ucxt) {
		this.ucxt = ucxt; // IK
		this.cxt = new ConfigurableResourceContext(ucxt.getUserClassLoader(),
				new String[] { ucxt.getUserHome() });
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.openl.IOpenParser#parseAsMethod(org.openl.IOpenSourceCodeModule)
	 */
	public IParsedCode parseAsMethodBody(IOpenSourceCodeModule m) {
		throw new UnsupportedOperationException(".xls files can not be parsed as a Method Body");
	}

	public IParsedCode parseAsMethodHeader(IOpenSourceCodeModule m) {
		throw new UnsupportedOperationException(".xls files can not be parsed as a Method Header");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.openl.IOpenParser#parseAsModule(org.openl.IOpenSourceCodeModule)
	 */
	public IParsedCode parseAsModule(IOpenSourceCodeModule m) {
		// IK: added ucxt
		return new XlsLoader(cxt, ucxt, getSearchPath()).parse(m);

	}

	public IParsedCode parseAsType(IOpenSourceCodeModule src) {
		throw new UnsupportedOperationException(".xls files can not be parsed as a Method Header");
	}

	String searchPath;

	static final String SEARCH_PROPERTY_NAME = "com.openrules.rules.include";
	// SEARCH_FILE_NAME =
	// "com/openrules/rules/com.openrules.rules.include.properties";
	static final String SEARCH_FILE_NAME = "com/openrules/com.openrules.properties";

	protected String getSearchPath() {
		if (searchPath != null) {
			return searchPath;
		}

		searchPath = PropertiesLocator.findPropertyValue(SEARCH_PROPERTY_NAME,
				SEARCH_FILE_NAME, cxt);
		return searchPath;

	}

}