/*
 * Created on Oct 7, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */

package com.openrules.lang.xls.binding;

import org.openl.binding.IBindingContext;
import org.openl.binding.IBoundNode;
import org.openl.binding.IMemberBoundNode;
import org.openl.binding.OpenLRuntimeException;
import org.openl.binding.impl.ABoundNode;
import org.openl.binding.impl.module.ModuleOpenClass;
import org.openl.types.IOpenClass;
import org.openl.types.impl.AOpenField;
import org.openl.types.impl.DynamicObject;
import org.openl.vm.IRuntimeEnv;
import com.openrules.lang.xls.syntax.XlsTableSyntaxNode;

import com.openrules.data.ITable;

/**
 * @author snshor
 *
 */
public class DataTableMethodBoundNode
	extends ABoundNode
	implements IMemberBoundNode
{


	DataOpenField field;

	XlsModuleOpenClass module;

	ITable table;



	/**
	 * @param syntaxNode
	 * @param children
	 */
	public DataTableMethodBoundNode(
		XlsTableSyntaxNode dtNode,
		ITable table,
		XlsModuleOpenClass module)
	{
		super(dtNode, IBoundNode.EMPTY);
		this.module = module;
		this.table = table;
	}

	/* (non-Javadoc)
	 * @see org.openl.binding.IMemberBoundNode#addTo(org.openl.binding.impl.module.ModuleOpenClass)
	 */
	public void addTo(ModuleOpenClass openClass)
	{
		openClass.addField(field = new DataOpenField(table));
	}
	
	
	
	
	
	

	/* (non-Javadoc)
	 * @see org.openl.binding.IMemberBoundNode#finalizeBind(org.openl.binding.IBindingContext)
	 */
	public void finalizeBind(IBindingContext cxt) throws Exception
	{

		module.getDataBase().validate();

	}

	/* (non-Javadoc)
	 * @see org.openl.binding.IBoundNode#evaluateRuntime(org.openl.vm.IRuntimeEnv)
	 */
	public Object evaluateRuntime(IRuntimeEnv env) throws OpenLRuntimeException
	{
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see org.openl.binding.IBoundNode#getType()
	 */
	public IOpenClass getType()
	{
		return field.getType();
	}

	static class DataOpenField extends AOpenField
	{
		ITable table;
		
//		Object data;

		/**
		* @param name
		* @param type
		*/
		public DataOpenField(ITable table)
		{
			super(table.getDataModel().getName(), table.getDataModel().getType().getAggregateInfo().getIndexedAggregateType(table.getDataModel().getType(), 1));
			this.table = table;
		}

		/**
		 *
		 */

		public Object get(Object target, IRuntimeEnv env)
		{
			Object data = ((DynamicObject)target).getFieldValue(name);
	
			
			if (data == null)
			{
				data = table.getDataArray();
				((DynamicObject)target).setFieldValue(name, data);
			}
			
			return data;
		}

		/**
		 *
		 */

		public void set(Object target, Object value, IRuntimeEnv env)
		{
			((DynamicObject)target).setFieldValue(name, value);
		}

		/**
		 *
		 */

		public boolean isWritable()
		{
			return true;
		}

	}

}
