/*
 * Copyright, 2009 OpenRules Inc.
 */


package com.openrules.lang.xls.binding;

import org.openl.OpenL;
import org.openl.binding.IBindingContext;
import org.openl.binding.IBindingContextDelegator;
import org.openl.binding.impl.module.ModuleOpenClass;
import org.openl.syntax.ISyntaxNode;

import com.openrules.dt.ExternalDTLoader;
import com.openrules.lang.xls.syntax.ExternalDTSyntaxNode;
import com.openrules.table.external.IRuleTable;

public class ExternalDataMethodBoundNode extends ProxyDecisionTableMethodBoundNode {

	
	public ExternalDataMethodBoundNode(ISyntaxNode dtNode,
			OpenL openl,
			ModuleOpenClass module,
			String temlateName, 
			String methodName) {
		super(dtNode, openl, module, temlateName, methodName);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.openl.binding.IMemberBoundNode#finalizeBind(org.openl.binding.IBindingContext)
	 */
	public void finalizeBind(IBindingContext cxt) throws Exception {

		ExternalDTSyntaxNode dtNode = (ExternalDTSyntaxNode) syntaxNode;

		IRuleTable table = dtNode.getRuleTable();

		new ExternalDTLoader().load( table, method, openl,module, (IBindingContextDelegator) cxt);

	}

}
