/*
 * Created on Oct 3, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */

package com.openrules.lang.xls.binding;

import org.openl.IOpenSourceCodeModule;
import org.openl.OpenL;
import org.openl.OpenlTool;
import org.openl.binding.IBindingContext;
import org.openl.binding.IBindingContextDelegator;
import org.openl.binding.IMemberBoundNode;
import org.openl.syntax.ISyntaxNode;
import org.openl.syntax.impl.SubTextSourceCodeModule;
import org.openl.types.IOpenMethodHeader;

import com.openrules.dt.SnippetPreprocessor;
import com.openrules.lang.xls.IXlsTableNames;
import com.openrules.lang.xls.syntax.XlsTableSyntaxNode;
import com.openrules.table.IGridTable;
import com.openrules.table.openl.GridCellSourceCodeModule;

/**
 * @author snshor
 *
 */
public class MethodTableNodeBinder extends AXlsTableBinder implements IXlsTableNames
{

	/* (non-Javadoc)
	 * @see com.openrules.lang.xls.binding.AXlsTableBinder#preBind(org.openl.syntax.ISyntaxNode, org.openl.OpenL, org.openl.binding.IBindingContext)
	 */
	public IMemberBoundNode preBind(
		ISyntaxNode syntaxNode,
		OpenL openl,
		IBindingContext cxt,
		XlsModuleOpenClass module)
	{

		XlsTableSyntaxNode methodNode =
			(XlsTableSyntaxNode) syntaxNode;

		IGridTable table = methodNode.getTable();


        IOpenSourceCodeModule src = new GridCellSourceCodeModule(table);
		//IOpenSourceCodeModule src = new SnippetPreprocessor(table);


		IOpenMethodHeader header = OpenlTool.getMethodHeader(
				new SubTextSourceCodeModule(src, methodNode.getHeader().length()), openl, (IBindingContextDelegator)cxt);

		return new MethodTableBoundNode(methodNode, openl, header, module);
	}

}
