/*
 * Created on Oct 28, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */

package com.openrules.table;

import com.openrules.table.ui.ICellStyle;

/**
 * @author snshor
 *
 */
public abstract class AGridTable extends ALogicalTable implements IGridTable
{

	/**
	 *
	 */

	public int getCellHeight(int column, int row)
	{
		return isNormalOrientation()
			? getGrid().getCellHeight(
				getGridColumn(column, row),
				getGridRow(column, row))
			: getGrid().getCellWidth(
				getGridColumn(column, row),
				getGridRow(column, row));
	}
	
	
	public boolean isPartOfTheMergedRegion(int column, int row)
	{
		return getGrid().isPartOfTheMergedRegion(getGridColumn(column, row), getGridRow(column, row));
	}
	

	/**
	 *
	 */

	public int getCellWidth(int column, int row)
	{
		return isNormalOrientation()
			? getGrid().getCellWidth(
				getGridColumn(column, row),
				getGridRow(column, row))
			: getGrid().getCellHeight(
				getGridColumn(column, row),
				getGridRow(column, row));
	}

	/**
	 *
	 */

	public ILogicalTable columnsInternal(int from, int to)
	{
		return new GridTableColumns(this, from, to);
	}

	/**
	 *
	 */

	public IGridTable getGridTable()
	{
		return this;
	}

	/**
	 *
	 */

	public int getLogicalHeight()
	{
		return getGridHeight();
	}

	/**
	 *
	 */

	public int getLogicalWidth()
	{
		return getGridWidth();
	}

	/**
	 *
	 */

	public ILogicalTable rowsInternal(int from, int to)
	{
		return new GridTableRows(this, from, to);
	}

	/**
	 *
	 */

	public ILogicalTable transpose()
	{
		return new TransposedGridTable(this);
	}

	/**
	 *
	 */

	public String getStringValue(int col, int row)
	{
		return getGrid().getStringCellValue(
			getGridColumn(col, row),
			getGridRow(col, row));
	}

	/**
	 *
	 */

	public String getUri(int col, int row)
	{
		return getGrid().getUri()
			+ "&"
			+ "cell="
			+ getGrid().getCellUri(getGridColumn(col, row), getGridRow(col, row));
	}


	public String getUri()
	{
		int w = getGridWidth();
		int h = getGridHeight();
		return getGrid().getUri()
			+ "&"
			+ "range="
			+ getGrid().getCellUri(getGridColumn(0, 0), getGridRow(0, 0))
			+ ":"
			+ getGrid().getCellUri(getGridColumn(w -1, h - 1), getGridRow(w - 1, h - 1));
	}


	/**
	 *
	 */

	public ILogicalTable getLogicalColumn(int column)
	{
		return columns(column, column);
	}

	/**
	 *
	 */

	public ILogicalTable getLogicalRow(int row)
	{
		return rows(row, row);
	}

	/**
	 *
	 */

	protected ILogicalTable getLogicalRegionInternal(
		int column,
		int row,
		int width,
		int height)
	{
		return new GridTableRegion(this, column, row, width, height);
	}

	/**
	 *
	 */

	public ICellStyle getCellStyle(int col, int row)
	{
		return getGrid().getCellStyle(
			getGridColumn(col, row),
			getGridRow(col, row));
	}

}
