/*
 * Created on Sep 19, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */

package com.openrules.table;

import java.util.Iterator;
import java.util.Vector;

/**
 * @author snshor
 *
 */
public class GridSplitter
{

  Vector tables = new Vector();

  IGrid grid;
  
  public GridSplitter(IGrid grid)
  {
  	this.grid = grid;
  }
  

  public IGridTable[] split()
  {

    int nrows = grid.getMaxRowIndex() + 1;

    for (int row = grid.getMinRowIndex(); row < nrows; row++)
    {

      int ncells = grid.getMaxColumnIndex(row) + 1;

      for (int col = grid.getMinColumnIndex(row); col < ncells; col++)
      {
				
				//skip empty cell        
				if (grid.isEmpty(col, row))  
					continue;

        //check if this cell was used
 
        if (cellIsUsed(col, row))
          continue;

          
          
        defineTableBoundaries(col, row);  
      }
    }
    
    return (IGridTable[])tables.toArray(new IGridTable[tables.size()]);
    
  }



	void defineTableBoundaries(int col, int row)
	{
		int y, x;
		for ( x = col; containsCell(x, row)  ; ++x);
		for ( y = row; containsRow(col, x, y)  ; ++y);
		
		tables.add(new GridTable(row, col, y - 1, x - 1, grid));		
		
	}
	
	boolean containsRow(int scol, int ecol, int row)
	{
		for (int col = scol; col < ecol; col++)
		{
			if (containsCell(col, row))
			  return true;
		}
		return false;
	}


	boolean containsCell(int x, int y)
	{
		return !grid.isEmpty(x, y) || grid.isPartOfTheMergedRegion(x, y);
	}

  boolean cellIsUsed(int col, int row)
  {
    for (Iterator iter = tables.iterator(); iter.hasNext();)
    {
      GridTable table = (GridTable)iter.next();
      if (GridTool.contains(table, col, row))
        return true;
    }
    return  false;
  }

}

