/*
 * Created on Oct 28, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */
 
package com.openrules.table;

import com.openrules.table.ui.ICellStyle;

/**
 * @author snshor
 *	
 * The class representing absolute grid starting at 0,0 
 *
 */
public interface IGrid
{

	int getMinRowIndex();
	int getMaxRowIndex();
	
	int getMinColumnIndex(int row);
	
	int getMaxColumnIndex(int row);
	
	int getNumberOfMergedRegions();
	
	IGridRegion getMergedRegion(int i);
	
	boolean isEmpty(int col, int row);
	
	String getStringCellValue(int column, int row);
	
	String getCellUri(int column, int row);

	ICellStyle getCellStyle(int column, int row);


	String getUri();


		
	boolean isPartOfTheMergedRegion(int col, int row);	
		
	/**
	 * Calculates cell height: if it is left top corner of merged region - returns region height, else - returns 1. 
	 */
	int getCellHeight(int column, int row);	

	/**
	 * @see #getCellHeight
	 */
	int getCellWidth(int column, int row);		

}
