/*
 * Copyright (C) 2009 OpenRules, Inc.
 * 
 */


package com.openrules.table.external;

import org.openl.util.text.ILocation;
import org.openl.util.text.IPosition;
import org.openl.util.text.TextInfo;

import com.openrules.table.external.ExternalDataPosition;

public class ExternalDataLocation implements ILocation {

	private ExternalDataPosition start;

	public ExternalDataLocation(int row, int col) {
		start = new ExternalDataPosition(row,col);
	}

	public IPosition getEnd() {
		return null;
	}

	public IPosition getStart() {
		return start;
	}

	public boolean isTextLocation() {
		return false;
	}

	public String toString() {
		return start.toString();
	}

	
}

class ExternalDataPosition implements IPosition {
	private int row;
	private int col;
	public ExternalDataPosition(int row, int col) {
		this.row = row;
		this.col = col;
	}

	public int getAbsolutePosition(TextInfo info) {
		return 0;
	}

	public int getColumn(TextInfo info, int tabSize) {
		return col;
	}

	public int getLine(TextInfo info) {
		return row;
	}

	public String toString() {
		return "row="+row+"&column="+col; 
	}
	
	
	
}