/*
 * Copyright (C) 2009 OpenRules, Inc.
 * 
 */

package com.openrules.table.external;

import java.io.InputStream;
import java.io.Reader;
import java.io.StringReader;

import org.openl.IOpenSourceCodeModule;

import com.openrules.table.external.IRuleTable;

public class ExternalDataSourceCodeModule implements IOpenSourceCodeModule {

	private final IRuleTable iRuleTable;

	public ExternalDataSourceCodeModule(IRuleTable iRuleTable) {
		this.iRuleTable = iRuleTable;
	}

	public IRuleTable getRuleTable() {
		return iRuleTable;
	}

	public InputStream getByteStream() {
		throw new UnsupportedOperationException();
	}

	public Reader getCharacterStream() {

		return new StringReader(getCode());
	}

	public String getCode() {
		return "";
	}

	/**
	 *
	 */

	public int getTabSize() {
		return 2;
	}

	public String getUri(int textpos) {
		return "ExternalRules#" + iRuleTable.getTableName();
	}

	public int getStartPosition() {
		return 0;
	}

}
