package com.openrules.table.external;



/*
 * Copyright (C) 2009 OpenRules, Inc.
 * 
 * Created on Feb-2009 by IK to support external rule tables
 */

public interface IRuleTable {
	/**
	 * @return a name of the table
	 */
	public String getTableName();
	
	/**
	 * @return a name of the template, e.g. "DecisionTableTemplate"
	 */
	public String getTemplateName();
	
	/**
	 * @return a RuleProvider that provides an access to table labels, variables, and a matrix of values
	 */
	public IRuleProvider getRules();
	
	/**
	 * @return a table type like "DecisionTable", "DecisionTable1", ...
	 */
	public String getTableType();
}

