/*
 * Created on Nov 8, 2003
 * Dec-2010: JF replaced '::= formula' to '"" + formula' - see getCode()
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */

package com.openrules.table.openl;

import java.io.InputStream;
import java.io.Reader;
import java.io.StringReader;

import org.openl.IOpenSourceCodeModule;

import com.openrules.table.IGridTable;

/**
 * @author snshor
 * 
 */
public class GridCellSourceCodeModule implements IOpenSourceCodeModule {

	IGridTable table;
	String code;

	public GridCellSourceCodeModule(IGridTable table) {
		this.table = table;
	}

	public InputStream getByteStream() {
		throw new UnsupportedOperationException();
	}

	/**
	 *
	 */

	public Reader getCharacterStream() {

		return new StringReader(getCode());
	}

	public String getCode() {
		if (code == null) {
			code = table.getStringValue(0, 0);

			if (code == null)
				code = "";

			if (code.startsWith("::=")) {
				//code = "\"\" + " + code.substring(3); 
				code = "\"\" + (" + code.substring(3) +")";  // to avoid a user adding (...)
			}
		}
		return code;
	}

	/**
	 *
	 */

	public int getTabSize() {
		return 2;
	}

	/**
	 *
	 */

	public String getUri(int textpos) {
		return table.getUri(0, 0);
	}

	public int getStartPosition() {
		return 0;
	}

}
