/*
 * Created on Nov 6, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */
 
package com.openrules.table.syntax;

import java.util.Map;

import org.openl.IOpenSourceCodeModule;
import org.openl.syntax.ISyntaxNode;
import org.openl.util.text.ILocation;

import com.openrules.table.ILogicalTable;

/**
 * @author snshor
 *
 */
public class TableSyntaxNode implements ISyntaxNode
{
	protected ILogicalTable table;
	protected String type;
	protected IOpenSourceCodeModule module;
	
	protected GridLocation location;
	
	
	protected TableSyntaxNode[] child;	
	
	
	public TableSyntaxNode(String type, ILogicalTable table)
	{
		this.type = type;
		this.table = table;
	}
	

	/**
	 *
	 */

	public ISyntaxNode getChild(int i)
	{
		return child[i];
	}

	/**
	 *
	 */

	public IOpenSourceCodeModule getModule()
	{
		return module;
	}

	/**
	 *
	 */

	public int getNumberOfChildren()
	{
		return child == null ? 0 : child.length;
	}

	/**
	 *
	 */

	public Map getProperties()
	{
		return null;
	}

	/**
	 *
	 */

	public ILocation getSourceLocation()
	{
		if (location == null)
		  location = table == null ? null : new GridLocation(table.getGridTable());
		return location;
	}

	/**
	 *
	 */

	public String getType()
	{
		return type;
	}

	/**
	 * @return
	 */
	public ILogicalTable getTable()
	{
		return table;
	}
	
	
	
	static TableSyntaxNode[] parseRows(String type, ILogicalTable table, int from, int to)
	{
		TableSyntaxNode[] nodes = new TableSyntaxNode[to - from + 1];
		
		for (int i = from; i <= to; i++)
		{
			nodes[i] = new TableSyntaxNode(type, table.getLogicalRow(i));
		}
		return nodes;
	}     
	
	
	static TableSyntaxNode[] parseRows(String type, ILogicalTable table, int from)
	{
		return parseRows(type, table, from, table.getLogicalWidth() - 1);
	}     
	

	
	static TableSyntaxNode[] parseColumns(String type, ILogicalTable table, int from, int to)
	{
		TableSyntaxNode[] nodes = new TableSyntaxNode[to - from + 1];
		
		for (int i = from; i <= to; i++)
		{
			nodes[i] = new TableSyntaxNode(type, table.getLogicalColumn(i));
		}
		return nodes;
	}     
	
	
	static TableSyntaxNode[] parseColumns(String type, ILogicalTable table, int from)
	{
		return parseRows(type, table, from, table.getLogicalHeight() - 1);
	}     
	
	/**
	 *
	 */

	public void print(int i, StringBuffer buf)
	{
		buf.append("@@TableNode");

	}

}
