package com.openrules.types;

public class BusinessObjectArray {
	
	
	Object[] objects;
	int[] numberOfSimilarObjects;
	boolean containsDuplicates;
	
	public BusinessObjectArray() {
		super();
		containsDuplicates = false;
	}
	
	public Object[] getObjects() {
		return objects;
	}

	public void setObjects(Object[] objects) {
		this.objects = objects;
		numberOfSimilarObjects = new int[objects.length];
		for (int i = 0; i < objects.length; i++) {
			numberOfSimilarObjects[i] = 0;
		}
	}
	
	public int[] getNumberOfSimilarObjects() {
		return numberOfSimilarObjects;
	}

	public void setNumberOfSimilarObjects(int[] numberOfSimilarObjects) {
		this.numberOfSimilarObjects = numberOfSimilarObjects;
	}
	
	public void calculateSimilarObjects(String[] propertiesToCompare) {
		setContainsDuplicates(false);
		for (int i = 0; i < objects.length; i++) {
			numberOfSimilarObjects[i] =0;
			for (int j = 0; j < objects.length; j++) {
				if ( j == i )
					continue;
				boolean similar= true;
				for (int k = 0; k < propertiesToCompare.length; k++) {
					if (!DataMap.compareTwoObjects(objects[i],objects[j],propertiesToCompare[k])) {
						similar = false;
						break;
					}
				}
				if (similar) {
					numberOfSimilarObjects[i]++;
					setContainsDuplicates(true);
				}
			}
		}
	}
	
	public boolean isContainsDuplicates() {
		return containsDuplicates;
	}

	public void setContainsDuplicates(boolean containsDuplicates) {
		this.containsDuplicates = containsDuplicates;
	}

	public static String getType(Object object) {
        if (object instanceof java.lang.String[])
            return "String[]";
        else 
        if (object instanceof int[])
            return "int[]";
        else 
        if (object instanceof long[])
            return "long[]";
        else 
        if (object instanceof double[])
            return "double[]";
        else 
        if (object instanceof boolean[])
            return "boolean[]";
        else 
        if (object instanceof java.util.Date[])
            return "Date[]";
        return null;
    }
	
	@Override
	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append("\nBusinessObjectArray:");
		if (objects != null)
		for (int i = 0; i < objects.length; i++) {
			buf.append("\n"+objects[i]);
			int n = numberOfSimilarObjects[i];
			if (n>0)
				buf.append(" "+ n + " duplicate(s)");
		}
		String yesno = "does not contain";
		if (containsDuplicates)
			yesno = "contains";
		buf.append("\nThis array " + yesno + " duplicates");
		return buf.toString();
	}

}
