package com.openrules.types;
/*
 * Copyright (C) 2007 OpenRules, Inc.
 */

/**
 * This type is used to represent domains of possible real numbers
 * inside rulesInMemory tables. The domain may be represented
 * by strings like "36.5, 3.14, -11.44". The expected delimeter is a Comma.
 *
 */


public class DomainDoubleC extends DomainDouble {
	
	public DomainDoubleC(String domain) {
		super(domain,",");
	}
	
	/**
	 * TEST
	 */
	public static void main(String[] args) {
		String[] domains = {
				"5.5, 10, 20.1,	40", 
				"10.3", 
				"-5.5, 7 , -10.1, 15",
				"-10, -20, 5.5000001",
				"10, -10.0"
				};
		double[] numbers = new double[] { 5.5, 7, 10.0, -10.0 };

		for (int i = 0; i < domains.length; i++) {
			try {
				DomainDoubleC domain = new DomainDoubleC(domains[i]);
				for (int j = 0; j < numbers.length; j++) {
					try {
					String result = " contains ";
					if (!domain.contains(numbers[j]))
						result = " does not contain ";
					System.out.println("Domain \"" + domain + "\"" + result
							+ numbers[j]);
					}
					catch (Exception e) {
						System.out.println("Invalid DomainInt \"" + domain + "\"");
					}
				}
			} catch (RuntimeException e) {
				System.out.println(e);
			}
		}
	}

}
