package com.openrules.types;
/*
 * Copyright (C) 2007 OpenRules, Inc.
 */

/**
 * This type is used to represent possible domains in integers
 * parameters inside rulesInMemory tables. The domain may be represented
 * by strings like "36,72,144". The expected divider is Comma.
 *
 */


public class DomainIntC extends DomainInt {
	
	public DomainIntC(String domain) {
		super(domain,",");
	}
	
	public DomainIntC(String domain, String delim) {
		super(domain,delim);
	}
	
	
	/**
	 * TEST
	 */
	public static void main(String[] args) {
		String[] domains = {
				"5, 10,15,40", 
				"10", 
				"-5,7,-10,15",
				"10 ,-20",
				"10, -10,  -5"
				};
		int[] numbers = new int[] { 5, 10, -10, -5, 15 };

		for (int i = 0; i < domains.length; i++) {
			try {
				DomainIntC domain = new DomainIntC(domains[i]);
				for (int j = 0; j < numbers.length; j++) {
					try {
					String result = " contains ";
					if (!domain.contains(numbers[j]))
						result = " does not contain ";
					System.out.println("Domain \"" + domain + "\"" + result
							+ numbers[j]);
					}
					catch (Exception e) {
						System.out.println("Invalid DomainInt \"" + domain + "\"");
					}
				}
			} catch (RuntimeException e) {
				System.out.println(e);
			}
		}
		
		DomainIntC domain = new DomainIntC(domains[2]);
		System.out.println("Elements in domain: "+domain);
		int[] elements = domain.getElements();
		for (int i = 0; i < elements.length; i++) {
			System.out.println(elements[i]);
		}
	}

}
