package com.openrules.types;
/*
 * Copyright (C) 2007 OpenRules, Inc.
 */

/**
 * This type is used to represent possible domains of Strings used inside rulesInMemory
 * tables. The domain may be represented by strings like "mom, son,daugther,sister".
 * The expected divider is a Comma.
 * 
 */

public class DomainStringC extends DomainString {

	public DomainStringC(String domain) {
		super(domain,",");
	}

	/**
	 * TEST
	 */
	public static void main(String[] args) {
		String[] domains = { "5,  son, daugther ,	sisters", " ", "son,dad", " A, B, C" };
		String[] texts = new String[] { "son", "sisters", "C" };

		for (int i = 0; i < domains.length; i++) {
			DomainStringC domain = new DomainStringC(domains[i]);
			for (int j = 0; j < texts.length; j++) {
				String result = " contains ";
				if (!domain.contains(texts[j]))
					result = " does not contain ";
				System.out.println("Domain \"" + domain + "\"" + result
						+ texts[j]);
			}
		}
		DomainString domain = new DomainStringC(domains[0]);
		System.out.println("Elements in domain: "+domain);
		String[] elements = domain.getElements();
		for (int i = 0; i < elements.length; i++) {
			System.out.println(elements[i]);
		}
		
		DomainString domain2 = new DomainStringC(domains[2]); 
		System.out.println("Domain <" + domain + "> intersects with domain <" + domain2 + ">: " +
				domain.intersectsWith(domain2));
	}
	
	
}
