package com.openrules.types;


/*
 * Copyright (c) 2005-2012 OpenRules, Inc. 	
 * Author: JF
 * Aug. 26, 2014: added Exclude All
 */

public class OperName {
	
	public static boolean isLT(String s) {
		return  s.equals("<") 
				|| s.equalsIgnoreCase("IsLess") 
				|| s.equalsIgnoreCase("Less") 
				|| s.equalsIgnoreCase("IsLessThan")
				|| s.equalsIgnoreCase("IsSmaller") 
				|| s.equalsIgnoreCase("Smaller") 
				|| s.equalsIgnoreCase("IsSmallerThan");
	}
	
	public static boolean isLE(String s) {
		return  s.equals("<=") 
				|| s.equalsIgnoreCase("IsLessOrEqual")
				|| s.equalsIgnoreCase("IsLessOrEqualTo")
				|| s.equalsIgnoreCase("IsLessThanOrEqualTo")
				|| s.equalsIgnoreCase("IsSmallerOrEqual")
				|| s.equalsIgnoreCase("IsSmallerOrEqualTo")
				|| s.equalsIgnoreCase("IsSmallerThanOrEqualTo");
	}

	public static boolean isEQ(String s) {
		return  s.equals("==") 
				|| s.equals("=")
				|| s.equalsIgnoreCase("Is");
	}

	public static boolean isNE(String s) {
		return  s.equals("!=") 
				|| s.equalsIgnoreCase("IsNot")
				|| s.equalsIgnoreCase("IsNotEqualTo")
				|| s.equalsIgnoreCase("Not")
				|| s.equalsIgnoreCase("NotEqualTo")
				|| s.equalsIgnoreCase("NotEqual");
	}

	public static boolean isGT(String s) {
		return  s.equals(">")  
				|| s.equalsIgnoreCase("IsMore")
				|| s.equalsIgnoreCase("More")
				|| s.equalsIgnoreCase("IsMoreThan")
				|| s.equalsIgnoreCase("IsGreater")
				|| s.equalsIgnoreCase("Greater")
				|| s.equalsIgnoreCase("IsGreaterThan");
	}

	public static boolean isGE(String s) {
		return  s.equals(">=") 
				|| s.equalsIgnoreCase("IsMoreOrEqual")
				|| s.equalsIgnoreCase("IsMoreOrEqualTo")
				|| s.equalsIgnoreCase("IsMoreThanOrEqualTo")
				|| s.equalsIgnoreCase("IsGreaterOrEqualTo")
				|| s.equalsIgnoreCase("IsGreaterThanOrEqualTo");
	}

	public static boolean isStartWith(String s) {
		return  s.equalsIgnoreCase("StartsWith") 
				|| s.equalsIgnoreCase("Starts")
				|| s.equalsIgnoreCase("Start");
	}

	public static boolean isContains(String s) {
		return  s.equalsIgnoreCase("Contains") 
				|| s.equalsIgnoreCase("Contain");
	}
	
	public static boolean isDoesNotContain(String s) {
		return  s.equalsIgnoreCase("DoesNotContain");
	}

	public static boolean isMatch(String s) {
		return  s.equalsIgnoreCase("Match")
				|| s.equalsIgnoreCase("Matches")
				|| s.equalsIgnoreCase("Is Like")
				|| s.equalsIgnoreCase("Like");
	}
	
	public static boolean isNoMatch(String s) {
		return  s.equalsIgnoreCase("NoMatch") 
				|| s.equalsIgnoreCase("NotMatch")
				|| s.equalsIgnoreCase("DoesNotMatch")
				|| s.equalsIgnoreCase("NotLike")
				|| s.equalsIgnoreCase("IsNotLike")
				|| s.equalsIgnoreCase("DifferentFrom")
				|| s.equalsIgnoreCase("Different");
	}

	public static boolean isWithin(String s) {
		return  s.equalsIgnoreCase("within") 
				|| s.equalsIgnoreCase("inside")
				|| s.equalsIgnoreCase("InsideInterval")
				|| s.equalsIgnoreCase("interval");
	}
	
	public static boolean isOutside(String s) {
		return  s.equalsIgnoreCase("outside") 
				|| s.equalsIgnoreCase("OutsideInterval");
	}
	
	public static boolean isAre(String s) {
		s = s.toLowerCase();
		return  s.startsWith("are");
	}
	
	public static boolean isAdd(String s) {
		s = s.toLowerCase();
		return  s.startsWith("add");
	}

	
	public static boolean isNotOneOf(String s) {
		s = s.toLowerCase();
		return  s.startsWith("isnotoneof")
				|| s.startsWith("isnotamong")
				|| s.startsWith("notamong");
	}

	public static boolean isOneOf(String s) {
		s = s.toLowerCase();
		return  s.startsWith("isoneof") 
				|| s.startsWith("isone")
				|| s.startsWith("isoneofmany")
				|| s.startsWith("isamong")
				|| s.startsWith("among");
	}

	public static boolean isInclude(String s) {
		s = s.toLowerCase();
		return  s.startsWith("include")  
				|| s.startsWith("includeall");
	}
	
	public static boolean isDoesNotInclude(String s) {
		s = s.toLowerCase();
		return  s.equals("doesnotinclude")  
				|| s.startsWith("includenotall");
	}
	
	public static boolean isExclude(String s) {
		s = s.toLowerCase();
		return  s.equals("exclude") 
				|| s.equals("donotinclude")
				|| s.equals("doesnotinclude")
				|| s.startsWith("excludeoneof");
	}
	
	public static boolean isExcludeAll(String s) {
		s = s.toLowerCase();
		return  s.equals("excludeall") 
				|| s.startsWith("donotincludeany")
				|| s.startsWith("doesnotincludeany");
	}

	public static boolean isIntersect(String s) {
		s = s.toLowerCase();
		return  s.startsWith("intersect") 
				|| s.startsWith("intersectwith")
				|| s.startsWith("intersects");
	}

	public static boolean isTrue(String s) {
		return  s.equalsIgnoreCase("IsTrue");
	}
	
	public static boolean isFalse(String s) {
		return  s.equalsIgnoreCase("IsFalse");
	}
	
	public static boolean isEmpty(String s) {
		return  s.equalsIgnoreCase("IsEmpty");
	}
 
	/*
		compound assignment operators:
		
		+=	assigns the result of the addition: var = var + value
		-=	assigns the result of the subtraction.
		*=	assigns the result of the multiplication
		/=	assigns the result of the division.
		 
	 */
	public static boolean isAssignPlus(String s) {
		return  s.equalsIgnoreCase("+=")
			 || s.equalsIgnoreCase("AssignPlus")
			 || s.equalsIgnoreCase("PlusAssign");
	}
	
	public static boolean isAssignMinus(String s) {
		return  s.equalsIgnoreCase("-=")
			 || s.equalsIgnoreCase("AssignMinus")
			 || s.equalsIgnoreCase("MinusAssign");
	}
	
	public static boolean isAssignMultiply(String s) {
		return  s.equalsIgnoreCase("*=")
			 || s.equalsIgnoreCase("AssignMultiply")
			 || s.equalsIgnoreCase("MultiplyAssign");
	}
	
	public static boolean isAssignDivide(String s) {
		return  s.equalsIgnoreCase("/=")
			 || s.equalsIgnoreCase("AssignDivide")
			 || s.equalsIgnoreCase("DivideAssign");
	}
	
//	public static boolean isMax(String s) {
//		return  s.equalsIgnoreCase("Max");
//	}
//	
//	public static boolean isMin(String s) {
//		return  s.equalsIgnoreCase("Min");
//	}
	
	public static boolean isOneElement(String oper) {
		if ("One Element".equalsIgnoreCase(oper) ||
			"One".equalsIgnoreCase(oper) ||
			"At Least One".equalsIgnoreCase(oper) ||
			"Is One Of".equalsIgnoreCase(oper)
			)
			return true;
		return false;
	}
	
	public static boolean isAllElements(String oper) {
		if ("All Elements".equalsIgnoreCase(oper) ||
			"All".equalsIgnoreCase(oper) ||
			"Every Element".equalsIgnoreCase(oper) ||
			"Every".equalsIgnoreCase(oper) ||
			"Each Element".equalsIgnoreCase(oper) ||
			"Each".equalsIgnoreCase(oper)
			)
			return true;
		return false;
	}
	
	public static boolean isMin(String oper) {
		if ("Min".equalsIgnoreCase(oper) ||
			"Minimal Element".equalsIgnoreCase(oper) 
			)
			return true;
		return false;
	}
	
	public static boolean isMax(String oper) {
		if ("Max".equalsIgnoreCase(oper) ||
			"Maximal Element".equalsIgnoreCase(oper) 
			)
			return true;
		return false;
	}
	
	public static boolean isAverage(String oper) {
		if ("Average".equalsIgnoreCase(oper) ||
			"Average Element".equalsIgnoreCase(oper) ||
			"Median".equalsIgnoreCase(oper) ||
			"Median Element".equalsIgnoreCase(oper) ||
			"Mean".equalsIgnoreCase(oper) ||
			"Mean Element".equalsIgnoreCase(oper) 
			)
			return true;
		return false;
	}
	
	public static boolean isCount(String oper) {
		if ("Count".equalsIgnoreCase(oper) ||
			"Total".equalsIgnoreCase(oper) ||
			"Number of Elements".equalsIgnoreCase(oper) 
			)
			return true;
		return false;
	}
	
	public static boolean isSum(String oper) {
		if ("Sum".equalsIgnoreCase(oper) )
			return true;
		return false;
	}
	
	public static boolean isProduct(String oper) {
		if ("Product".equalsIgnoreCase(oper) )
			return true;
		return false;
	}
	
	public static boolean isArrayOperator(String oper) {
		return isMin(oper) || isMax(oper) || isAverage(oper) || isContains(oper)
				|| isSum(oper) || isProduct(oper);
	}

}
