package com.openrules.data;

import java.util.ArrayList;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.beanutils.BasicDynaClass;
import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.beanutils.DynaBean;
import org.apache.commons.beanutils.DynaClass;
import org.apache.commons.beanutils.DynaProperty;
import org.apache.commons.beanutils.PropertyUtils;
import org.openl.types.impl.DynamicObject;

public class TestPropertyUtils {

	public static void main(String[] args) {
		
		try {
			Object movie = createMovieBean();
			System.out.println(BeanUtils.getProperty(movie, "title"));
			// //property = PropertyUtils.getSimpleProperty(object, name);
			Object property = PropertyUtils.getSimpleProperty(movie, "title");
			System.out.println("property="+property);
			// type = PropertyUtils.getPropertyType(object, name).getName();

		} catch (Exception e) {
			System.err.println("Cannot create MovieBean");
		}

	}

	private static Object createMovieBean() throws Exception {

		// first create the properties
		DynaProperty properties[] = new DynaProperty[] {
				new DynaProperty("title", String.class),
				new DynaProperty("dateOfRelease", Date.class),
				new DynaProperty("keywords", String[].class),
				new DynaProperty("genre", Map.class),
				new DynaProperty("actors", List.class), };

		// next using the properties define the class
		DynaClass movieClass = new BasicDynaClass("movie", null, properties);

		// now, with the class, create a new instance
		DynaBean movieBean = movieClass.newInstance();

		// set its properties
		movieBean.set("title", "The Italian Job");
		movieBean.set("dateOfRelease",
				new GregorianCalendar(1969, 0, 1).getTime());
		movieBean.set("keywords", new String[] { "Italy", "Bank Robbery" });

		Map genre = new HashMap();
		genre.put("THR", "Thriller");

		movieBean.set("genre", genre);
		movieBean.set("genre", "ACT", "Action");

		return movieBean;
	}

}
