package com.openrules.datasource;

/*
 * Copyright (C) 2006-2009 OpenRules, Inc.
 * 
 * Created on August, 2006 by IK
 * 
 */

/**
 * Contains common methods for different data sources
 * @see URLDataSource
 * 
 * @author IK
 *  
 */

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;


public abstract class AbstractDataSource implements IDataSource {

	public byte[] getByteArray() throws IOException {
        InputStream is = getInputStream();
        try {
            return Utils.copyToByteArray( is );
          
        } finally {
            Utils.justClose( is );
        }
    }

    public String getString() throws IOException {
        Reader r = getReader();
        try {
            return Utils.copyToString( r );
          
        } finally {
            Utils.justClose( r );
        }
    }

	public Reader getReader() throws IOException {
        InputStream is = getInputStream();
		return (is== null ? null : new InputStreamReader( is ) );
	}
    

}


