package com.openrules.datasource;

/*
 * Copyright (C) 2006-2009 OpenRules, Inc.
 * 
 * Created on August, 2006 by IK
 * 
 */

import java.io.IOException;
import java.io.InputStream;
import java.io.Reader;
import java.net.URI;

import org.openl.syntax.impl.ASourceCodeModule;
import org.openl.util.RuntimeExceptionWrapper;

public class DataSourceCodeModule extends ASourceCodeModule {

	private IDataSource dataSource;

	public DataSourceCodeModule(IDataSource dataSource) {
		this.dataSource = dataSource;
	}

	public String getUri(int textpos) {
		URI uri = dataSource.getURI();
		return ( uri == null ? null : uri.toASCIIString() );
	}

	public InputStream getByteStream() {
		try {
			return dataSource.getInputStream();
		} catch (IOException e) {
			throw RuntimeExceptionWrapper.wrap(e);
		}
	}

	public Reader getCharacterStream() {
		try {
			return dataSource.getReader();
		} catch (IOException e) {
			throw RuntimeExceptionWrapper.wrap(e);
		}
	}

}
