package com.openrules.datasource;

/*
 * Copyright (C) 2006-2009 OpenRules, Inc.
 * 
 * Created on August, 2006 by IK
 * 
 */

/**
 *	DataSourceFactory is responsible for the creation of DataSources
 *  that provide a unified access to different data sources such as xls- and 
 *  xml-files using prefixes such as "classpath:", "file:", "http:", "ftp:" 
 *  
 *  @author IK
 *  
 */


import java.net.MalformedURLException;
import java.net.URI;
import java.util.Properties;

import org.openl.util.Log;

public class URLDataSourceFactoryHandler implements IDataSourceProtocolHandler  {
	
	public IDataSource fromURI( URI uri, IDataSourceFactory dataSourceFactory ) {
		Log.debug("Create DataSource from " + uri);
		if (uri == null)
			throw new IllegalArgumentException();

		try {
			return new URLDataSource( uri.toURL() );
		} catch (MalformedURLException e) {
			throw new RuntimeException( "Unable to create data source", e );
		}
	}

	public void initialize(Properties options) {
		//nothing
	}

}