/*
 * Created on Jul 9, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */
 
package org.openl.binding.impl;

import org.openl.binding.IBoundNode;
import org.openl.binding.OpenLRuntimeException;
import org.openl.types.IOpenCast;
import org.openl.types.IOpenClass;
import org.openl.vm.IRuntimeEnv;

/**
 * @author snshor
 *
 */
public class CastNode extends ABoundNode
{
	
	IOpenCast cast;
	IOpenClass castedType;
	
	protected IBoundNode bnode;

  /**
   * @param syntaxNode
   * @param children
   */
  public CastNode(IBoundNode bnode, IOpenCast cast, IOpenClass castedType)
  {
  	super(bnode.getSyntaxNode(), bnode.getChildren());
  	this.cast = cast;
  	this.bnode = bnode;
  	this.castedType = castedType;
  }

  /* (non-Javadoc)
   * @see org.openl.binding.IBoundNode#assign(java.lang.Object, org.openl.vm.IRuntimeEnv)
   */
  public void assign(Object value, IRuntimeEnv env) throws OpenLRuntimeException
  {
  	bnode.assign(value, env);
  }

  /* (non-Javadoc)
   * @see org.openl.binding.IBoundNode#evaluate(org.openl.vm.IRuntimeEnv)
   */
	public Object evaluateRuntime(IRuntimeEnv env) throws OpenLRuntimeException
  {
  	Object res = bnode.evaluate(env);
    return cast.convert(res);
  }



  /* (non-Javadoc)
   * @see org.openl.binding.IBoundNode#getTargetNode()
   */
  public IBoundNode getTargetNode()
  {
    return null;
  }

  /* (non-Javadoc)
   * @see org.openl.binding.IBoundNode#getType()
   */
  public IOpenClass getType()
  {
    return castedType;
  }

  /* (non-Javadoc)
   * @see org.openl.binding.IBoundNode#isLvalue()
   */
  public boolean isLvalue()
  {
    return bnode.isLvalue();
  }

}
