/*
 * Created on Jul 25, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */
 
package org.openl.binding.impl.module;

import java.util.Vector;

import org.openl.binding.IBoundNode;
import org.openl.types.IAggregateInfo;
import org.openl.types.IMemberMetaInfo;
import org.openl.types.IMethodSignature;
import org.openl.types.IOpenClass;
import org.openl.types.IOpenMethod;
import org.openl.types.IOpenSchema;
import org.openl.types.impl.ADynamicClass;
import org.openl.types.impl.DynamicArrayAggregateInfo;
import org.openl.types.impl.DynamicObject;
import org.openl.types.java.JavaOpenClass;
import org.openl.vm.IRuntimeEnv;

/**
 * @author snshor
 *
 */
public class ModuleOpenClass extends ADynamicClass
{

	
	DefaultInitializer init;


	public Object newInstance(IRuntimeEnv env)
	{
		DynamicObject res = new DynamicObject(this);
		init.invoke(res, new Object[]{}, env);
		return res;
	} 

  /**
   * @param schema
   * @param name
   */
  public ModuleOpenClass(IOpenSchema schema, String name)
  {
    super(schema, name, DynamicObject.class);
    init = new DefaultInitializer();
  }
  
  public void addInitializerNode(IBoundNode node)
  {
  	init.addNode(node);
  }
  
  
  class DefaultInitializer implements IOpenMethod
  {
		Vector boundNodes = new Vector();	
      /* (non-Javadoc)
     * @see org.openl.types.IOpenMethod#getParameterTypes()
     */
    public IMethodSignature getSignature()
    {
      return IMethodSignature.VOID;
    }
    
    
    
    public void addNode(IBoundNode node)
    {
    	boundNodes.add(node);
    }

    /* (non-Javadoc)
     * @see org.openl.types.IOpenMember#getDeclaringClass()
     */
    public IOpenClass getDeclaringClass()
    {
      return ModuleOpenClass.this;
    }

    /* (non-Javadoc)
     * @see org.openl.types.IOpenMember#getInfo()
     */
    public IMemberMetaInfo getInfo()
    {
      return null;
    }

    /* (non-Javadoc)
     * @see org.openl.types.IOpenMember#getType()
     */
    public IOpenClass getType()
    {
      return JavaOpenClass.VOID;
    }

    /* (non-Javadoc)
     * @see org.openl.types.IOpenMember#isStatic()
     */
    public boolean isStatic()
    {
      return false;
    }

    /* (non-Javadoc)
     * @see org.openl.types.IMethodCaller#getMethod()
     */
    public IOpenMethod getMethod()
    {
      return this;
    }

    /* (non-Javadoc)
     * @see org.openl.types.IMethodCaller#invoke(java.lang.Object, java.lang.Object[], org.openl.vm.IRuntimeEnv)
     */
    public Object invoke(Object target, Object[] params, IRuntimeEnv env)
    {
      try
      {
      	env.pushThis(target);
        for (int i = 0; i < boundNodes.size(); i++)
        {
        	IBoundNode node = (IBoundNode) boundNodes.elementAt(i);
        	node.evaluate(env);        
        }
        
        return null;
      }
      finally 
      {
      	env.popThis();
      }
    }

    /* (non-Javadoc)
     * @see org.openl.base.INamedThing#getName()
     */
    public String getName()
    {
      // TODO Auto-generated method stub
      return null;
    }

}
  

	/**
	 *
	 */

	public IAggregateInfo getAggregateInfo()
	{
		return DynamicArrayAggregateInfo.aggregateInfo;
	}

}
