/*
 * Created on Jul 8, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */
 
package org.openl.conf;

import org.openl.OpenConfigurationException;
import org.openl.types.IOpenFactory;
import org.openl.types.impl.AOpenFactory;

import com.openrules.datasource.IDataSourceFactory;

/**
 * @author snshor
 * 
 * Modified by IK on 08/07/2006: add dataSourceFactory
 *
 */
public class OpenFactoryConfiguration extends AGenericConfiguration implements IOpenFactoryConfiguration
{

	protected String name;
	protected IOpenFactory factory;
	private IDataSourceFactory dataSourceFactory; //IK

  /* (non-Javadoc)
   * @see org.openl.conf.AGenericConfiguration#getImplementingClass()
   */
  public Class getImplementingClass()
  {
    return IOpenFactory.class;
  }
  
  
  
  public IDataSourceFactory getDataSourceFactory() {
	return dataSourceFactory;
}



public void setDataSourceFactory(IDataSourceFactory dataSourceFactory) {
	this.dataSourceFactory = dataSourceFactory;
}



public IOpenFactory getOpenFactory(IConfigurableResourceContext cxt)
  {
  	if (factory == null)
  	  factory = (IOpenFactory) createResource(cxt);
  	
  	//refactor later
  	if ( factory instanceof AOpenFactory)
  		((AOpenFactory)factory).setDataSourceFactory(dataSourceFactory);
  	return factory;  
  }

  /**
   * @return
   */
  public String getName()
  {
    return name;
  }

  /**
   * @param string
   */
  public void setName(String string)
  {
    name = string;
  }

  /* (non-Javadoc)
   * @see org.openl.conf.IConfigurationElement#validate(org.openl.conf.IConfigurableResourceContext)
   */
  public void validate(IConfigurableResourceContext cxt)
    throws OpenConfigurationException
  {
  	if (name == null)
  	  throw new OpenConfigurationException("Factory must have a name", getUri(), null);
  	
    super.validate(cxt);
  }

}
