/*
 * Created on Dec 2, 2004
 *
 * Developed by OpenRules, Inc. 2003,2004
 */
package org.openl.syntax.impl;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.URL;

import org.openl.util.RuntimeExceptionWrapper;

/**
 * @author snshor
 */
public class URLSourceCodeModule extends ASourceCodeModule
{

  URL url;

  public URLSourceCodeModule(URL url)
  {
    this.url = url;
  }
  

  public String getUri(int textpos)
  {
    return url.toExternalForm();
  }

  public InputStream getByteStream()
  {
    
    try
    {
      return url.openStream();
    } catch (IOException e)
    {
      throw RuntimeExceptionWrapper.wrap(e);
    }
  }

  public Reader getCharacterStream()
  {
    return new InputStreamReader(getByteStream());
  }

}