/*
 * Created on Jun 30, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */

package org.openl.types.impl;

import java.util.HashMap;

import org.openl.types.IOpenFactory;
import org.openl.types.IOpenSchema;

import com.openrules.datasource.IDataSourceFactory;

/**
 * @author snshor
 * 
 * Modified by IK on 08/07/2006: added dataSourceFactory
 * 
 */
public abstract class AOpenFactory implements IOpenFactory {
	IDataSourceFactory dataSourceFactory;

	HashMap schemaPool = new HashMap();

	public IDataSourceFactory getDataSourceFactory() {
		return dataSourceFactory;
	}

	public void setDataSourceFactory(IDataSourceFactory dataSourceFactory) {
		this.dataSourceFactory = dataSourceFactory;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.openl.types.IOpenFactory#getSchema(java.lang.String, boolean)
	 */
	public synchronized IOpenSchema getSchema(String uri, boolean reload)
			throws Exception {
		IOpenSchema schema = null;
		if (!reload) {
			schema = (IOpenSchema) schemaPool.get(uri);
			if (schema != null)
				return schema;
		}

		schema = loadSchema(uri);

		if (schema == null)
			schemaPool.remove(uri);
		else
			schemaPool.put(uri, schema);

		return schema;
	}

	public abstract IOpenSchema loadSchema(String uri) throws Exception;

}
