/*
 * Created on Jul 3, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */

package org.openl.types.impl;

import org.openl.types.IMemberMetaInfo;
import org.openl.types.IMethodSignature;
import org.openl.types.IOpenClass;
import org.openl.types.IOpenMethod;

/**
 * @author snshor
 *
 */
public abstract class AOpenMethod implements IOpenMethod
{

  
  IMethodSignature signature;
  protected IOpenClass declaringClass;
  protected IOpenClass typeClass;
  

  protected String name;
  protected boolean isStatic;

  protected IMemberMetaInfo info;

  /**
   * 
   */
  public AOpenMethod(
    String name,
    IOpenClass typeClass,
	  IMethodSignature signature,
    IOpenClass declaringClass,
    boolean isStatic,
    IMemberMetaInfo info)
  {
    this.name = name;
    this.typeClass = typeClass;
    this.signature = signature;
    this.declaringClass = declaringClass;
    this.isStatic = isStatic;
    this.info = info;
  }

  public AOpenMethod(
    String name,
    IOpenClass typeClass,
	  IMethodSignature signature,
    IOpenClass declaringClass)
  {
    this(name, typeClass, signature, declaringClass, false, null);
  }



  /* (non-Javadoc)
   * @see org.openl.types.IOpenMember#getDeclaringClass()
   */
  public IOpenClass getDeclaringClass()
  {
    return declaringClass;
  }

  /* (non-Javadoc)
   * @see org.openl.types.IOpenMember#getType()
   */
  public IOpenClass getType()
  {
    return typeClass;
  }

  /* (non-Javadoc)
   * @see org.openl.types.IOpenMember#getInfo()
   */
  public IMemberMetaInfo getInfo()
  {
    return info;
  }

  /* (non-Javadoc)
   * @see org.openl.types.IOpenMember#isStatic()
   */
  public boolean isStatic()
  {
    return isStatic;
  }

  /* (non-Javadoc)
   * @see org.openl.types.IMethodCaller#getMethod()
   */
  public IOpenMethod getMethod()
  {
    return this;
  }

  /* (non-Javadoc)
   * @see org.openl.base.INamedThing#getName()
   */
  public String getName()
  {
    return name;
  }


  /**
   * @return
   */
  public IMethodSignature getSignature()
  {
    return signature;
  }

}
