/*
 * Created on Jun 3, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */
 
package org.openl.binding;

import java.util.Iterator;
import java.util.List;

import org.openl.types.IOpenClass;
import org.openl.types.IOpenMethod;

/**
 * @author snshor
 *
 */
public class AmbiguousMethodException extends RuntimeException
{


	List matchingMethods; 
	String methodName; 
	IOpenClass[] pars;
	
	public AmbiguousMethodException( String methodName, IOpenClass[] pars, List matchingMethods)
	{
		this.methodName = methodName;
		this.pars = pars;
		this.matchingMethods = matchingMethods; 
	}
	
	public String getMessage()
	{
		StringBuffer buf = new StringBuffer();
		
		buf.append("Method ");
		Util.printMethod(methodName, pars, buf);
		buf.append(" is ambigous:\n").
		append("Matching methods:\n");
		for (Iterator iter = matchingMethods.iterator(); iter.hasNext();)
    {
			IOpenMethod method = (IOpenMethod)iter.next();
      Util.printMethod(method, buf).append('\n');
    }
		
		
		return buf.toString();
	}



}
