/*
 * Created on Oct 7, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */

package org.openl.types;

/**
 * @author snshor
 *
 */
public interface IMethodSignature
{

	public static final IMethodSignature VOID = new VoidSignature();

	public IOpenClass[] getParameterTypes();

	public String getParameterName(int i);

	public int getParameterDirection(int i);

	static final class VoidSignature implements IMethodSignature
	{
		/* (non-Javadoc)
		* @see org.openl.types.IMethodSignature#getParameterDirection(int)
		*/
		public int getParameterDirection(int i)
		{
			throw new IndexOutOfBoundsException();
		}

		/* (non-Javadoc)
		 * @see org.openl.types.IMethodSignature#getParameterName(int)
		 */
		public String getParameterName(int i)
		{
			throw new IndexOutOfBoundsException();
		}

		/* (non-Javadoc)
		 * @see org.openl.types.IMethodSignature#getParameterTypes()
		 */
		public IOpenClass[] getParameterTypes()
		{
			return IOpenClass.EMPTY;
		}

	}

}
