/*
 * Created on Jul 1, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */
 
package org.openl.types.xml;

import org.openl.types.IOpenClass;
import org.openl.types.java.JavaOpenClass;
import org.openl.vm.IRuntimeEnv;
import org.w3c.dom.Attr;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

/**
 * @author snshor
 *
 */
public class DOMAttributeNodeField extends DOMField
{

	

	/**
	 * @param name
	 * @param declaringClass
	 */
	public DOMAttributeNodeField(String name, IOpenClass declaringClass)
	{
		super(name, declaringClass);
	}

	/* (non-Javadoc)
	* @see org.openl.types.IOpenField#get(java.lang.Object)
	*/
	public Object get(Object target, IRuntimeEnv env)
	{
		Node parent = (Node)target;
		//TODO check existence of the attribute and then return null, otherwise propagate exception 
    try
    {
      return parent.getAttributes().getNamedItem(this.name).getNodeValue();
    }
    catch (Throwable e)
    {
      return null;
    }
	}

	public IOpenClass getType()
	{
		return JavaOpenClass.STRING;
	}
	/* (non-Javadoc)
	 * @see org.openl.types.IOpenField#set(java.lang.Object, java.lang.Object)
	 */
	public void set(Object target, Object value, IRuntimeEnv env)
	{
		Node parent = (Node)target;
		NamedNodeMap attrs = parent.getAttributes();
		Attr attr =  parent.getOwnerDocument().createAttribute(this.name);
		attr.setNodeValue((String)value);
		 
		attrs.setNamedItem(attr);
	}

}

