/*
 * Created on Jul 1, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */
 
package org.openl.types.xml;

import org.openl.types.IOpenClass;
import org.openl.types.IOpenField;
import org.openl.types.IMemberMetaInfo;
import org.openl.vm.IRuntimeEnv;

/**
 * @author snshor
 *
 */
public abstract class DOMField implements IOpenField
{
	protected String name;
	protected IOpenClass declaringClass;

	protected DOMField(String name, IOpenClass declaringClass)
	{
		this.name = name;
		this.declaringClass = declaringClass;
	}
	/**
	 * @return
	 */
	public String getName()
	{
		return name;
	}

	public IOpenClass getDeclaringClass()
	{
		return declaringClass;
	}

	public void set(Object target, Object value, IRuntimeEnv env)
	{
		throw new UnsupportedOperationException();
	}

	public boolean isStatic()
	{
		return false;
	}

	public IMemberMetaInfo getInfo()
	{
		return null;
	}

	public boolean isConst()
	{
		return true;
	}

	public boolean isReadable()
	{
		return true;
	}

	public boolean isWritable()
	{
		return true;
	}
}
