/*
 * Created on Jun 19, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */
 
package org.openl.types.xml;

import java.util.Iterator;

import org.openl.binding.AmbiguousMethodException;
import org.openl.binding.IOpenLibrary;
import org.openl.types.IOpenClass;
import org.openl.types.IOpenField;
import org.openl.types.IOpenMethod;
import org.openl.types.impl.ConstOpenField;
import org.openl.util.OpenIterator;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

/**
 * @author snshor
 *
 */
public class DOMOpenLibrary implements IOpenLibrary
{
	boolean triedToLoad = false;
	String rootName = null;

	//TODO fix to use factory	
	DOMOpenSchema schema = new DOMOpenSchema(null, null);

	IOpenField rootVar = null;	

	
	
	public void setProperty(String name, String value)
	{
		if (name.equals("rootname"))
		  rootName = value;
		else
		{
			throw new RuntimeException("DOMOpenLibrary supports only property <rootname>");
		}  
	}
	
	
//	Document getDocument()
//	{
//		if (doc != null)
//		  return doc;
//		  
//		if (triedToLoad)
//		  return null;
//		triedToLoad = true;    
//		
//		DOMParser parser = new DOMParser();
//  
//		try
//		{
//			parser.parse(xmlSource);
//		} 
//		catch(Throwable t)
//		{
//			try
//			{
//				parser.parse(xmlSource);
//			}
//			catch(Throwable tt)
//			{
//				throw RuntimeExceptionWrapper.wrap("Can not load " + xmlSource ,tt);
//			}
//		}
//		
//		doc = parser.getDocument();
//		
//		return doc;
//		 
//	}

  /* (non-Javadoc)
   * @see org.openl.binding.IMethodFactory#getMatchingMethod(java.lang.String, org.openl.types.IOpenClass[])
   */
  public IOpenMethod getMatchingMethod(String name, IOpenClass[] params)
    throws AmbiguousMethodException
  {
    return null;
  }

  /* (non-Javadoc)
   * @see org.openl.binding.IMethodFactory#methods()
   */
  public Iterator methods()
  {
    return OpenIterator.EMPTY;
  }

	protected IOpenField getRootVar()
	{
		if (rootVar != null)
			return rootVar;
		
		Document doc = schema.getDocument();
		
		Node firstChild = doc.getFirstChild();
		
//		System.out.println("Node name:" + firstChild.getNodeName());
		
		rootName = rootName == null ? firstChild.getNodeName() : rootName;
		
		
		rootVar  = new ConstOpenField(rootName, firstChild, schema.getType(firstChild.getNodeName()));
		return rootVar;    	
	}

  /* (non-Javadoc)
   * @see org.openl.binding.IVarFactory#getVar(java.lang.String)
   */
  public  synchronized IOpenField getVar(String name)
  { 
  	if (rootName == null)
  	{
  		rootName = getRootVar().getName();
  	}
  	
  	if (!rootName.equals(name))
    	return null;
    	
		if (rootVar == null)
		{
			rootVar = getRootVar();
		}
		
		return rootVar; 
		
  }

}
