/*
 * Created on Jun 23, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */

package org.openl.types.xml;

import java.io.FileWriter;

import org.apache.xerces.parsers.DOMParser;
import org.apache.xml.serialize.LineSeparator;
import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.xml.sax.InputSource;

/**
 * @author snshor
 *
 */
public class DomUtil
{

  static public String getLongName(Node node)
  {
    StringBuffer buf = new StringBuffer();
    makeNodeName(node, buf);
    return buf.toString();
  }

  static void makeNodeName(Node node, StringBuffer buf)
  {
    if (node.getParentNode() == null)
    {
      buf.append(node.getNodeName());
      return;
    }
    else
    {
      makeNodeName(node.getParentNode(), buf);
      buf.append('.').append(node.getNodeName());
    }
  }

  static public void addNode(Node node, Node parent)
  {
    parent.appendChild(node);
  }

  static public Node findNode(String nodeName, int index, Node parent)
  {
    int i = 0;
    for (Node child = parent.getFirstChild();
      child != null;
      child = child.getNextSibling())
    {
      if (child.getNodeName().equals(nodeName))
      {
        if (i == index)
          return child;
        ++i;
      }
    }

    return null;
  }

  static public int countNodes(String nodeName, Node parent)
  {
    int cnt = 0;
    for (Node child = parent.getFirstChild();
      child != null;
      child = child.getNextSibling())
    {
      if (child.getNodeName().equals(nodeName))
      {
        ++cnt;
      }
    }

    return cnt;
  }

  static public Document getDocument(InputSource isource) throws Exception
  {
    DOMParser parser = new DOMParser();

    parser.parse(isource);

    return parser.getDocument();

  }

  public static void saveNodeAsDocument(String filename, Node node)
    throws Exception
  {
    Document doc = node.getOwnerDocument();
    Document newDoc = (Document)doc.cloneNode(false);
    
//    Node docNode = doc.getDocumentElement();
//    newDoc.importNode(docNode, false);
    Node newNode = newDoc.importNode(node, true);
    newDoc.appendChild(newNode);

    OutputFormat format = new OutputFormat(newDoc);
    format.setLineSeparator(LineSeparator.Windows);
    format.setIndenting(true);
    format.setLineWidth(4);
    format.setPreserveSpace(false);
//    System.out.println("Start Serializing " + filename);
    XMLSerializer serializer =
      new XMLSerializer(new FileWriter(filename), format);
    serializer.asDOMSerializer();
    serializer.serialize(newDoc);
//		System.out.println("End Serializing " + filename);

  }

}
