/*
 * Created on Jul 1, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */
 
package org.openl.binding.impl;

import org.openl.binding.IBindingContext;
import org.openl.binding.IBoundNode;
import org.openl.syntax.ISyntaxNode;
import org.openl.types.IOpenCast;
import org.openl.types.IOpenClass;

/**
 * @author snshor
 *
 */
public class ArrayInitializationBinder extends ANodeBinder
{



  /* (non-Javadoc)
   * @see org.openl.binding.INodeBinder#bindType(org.openl.syntax.ISyntaxNode, org.openl.binding.IBindingContext, org.openl.types.IOpenClass)
   */
  public IBoundNode bindType(
    ISyntaxNode node,
    IBindingContext bindingContext,
    IOpenClass type)
    throws Exception
  {
  	
  	IOpenClass componentType = type.getAggregateInfo().getComponentType(type);

  	IBoundNode[] nodes = bindTypeChildren(node, bindingContext, componentType);
  	IOpenCast[] casts = new IOpenCast[nodes.length];
  	
  	for (int i = 0; i < nodes.length; i++)
    {
      casts[i] = getCast(nodes[i].getType(), componentType, bindingContext);
    }
    
    return new ArrayInitializerNode(node,  nodes, type, casts);
  	
  }

  /* (non-Javadoc)
   * @see org.openl.binding.INodeBinder#bind(org.openl.syntax.ISyntaxNode, org.openl.binding.IBindingContext)
   */
  public IBoundNode bind(ISyntaxNode node, IBindingContext bindingContext)
    throws Exception
  {
  	throw new UnsupportedOperationException("Array has always to be initialized with a type");
  }

}
