package org.openl.binding.impl;
/*
 * Copyright OpenRules, Inc. 2009
 */

/**
 * June-2009: IK added this class to support
 * a "shameless" hack to get around "or" children evaluation bug 
 */

import org.openl.binding.IBoundNode;
import org.openl.binding.OpenLRuntimeException;
import org.openl.syntax.ISyntaxNode;
import org.openl.types.IOpenClass;
import org.openl.types.java.JavaOpenClass;
import org.openl.vm.IRuntimeEnv;

public class OrOpNode extends ABoundNode {

	private IOpenClass type = JavaOpenClass.getOpenClass(boolean.class);

	public OrOpNode(ISyntaxNode syntaxNode, IBoundNode[] child) {
		super(syntaxNode, child);
	}

	public Object evaluateRuntime(IRuntimeEnv env) throws OpenLRuntimeException {
		for (int i = 0; i < children.length; i++) {
			Boolean v = (Boolean) children[i].evaluate(env);
			if ( v.booleanValue() )
				return Boolean.TRUE;
	    }
		return Boolean.FALSE;
	}

	public IOpenClass getType() {
		return type;
	}

}
