/*
 * Created on Jul 28, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */
 
package org.openl.binding.impl;

import org.openl.binding.IBoundNode;
import org.openl.binding.OpenLRuntimeException;
import org.openl.syntax.ISyntaxNode;
import org.openl.types.IOpenClass;
import org.openl.types.NullOpenClass;
import org.openl.vm.IRuntimeEnv;

/**
 * @author snshor
 *
 */
public class ReturnNode extends ABoundNode
{

  /**
   * @param syntaxNode
   * @param children
   */
  public ReturnNode(ISyntaxNode syntaxNode, IBoundNode[] children)
  {
    super(syntaxNode, children);
  }

  /* (non-Javadoc)
   * @see org.openl.binding.IBoundNode#getType()
   */
  public IOpenClass getType()
  {
    return NullOpenClass.the;
  }

  /* (non-Javadoc)
   * @see org.openl.binding.IBoundNode#evaluate(org.openl.vm.IRuntimeEnv)
   */
	public Object evaluateRuntime(IRuntimeEnv env) throws OpenLRuntimeException
  {
  	IBoundNode exprNode = children.length == 0 ? null : children[0];
  	Object returnValue = exprNode == null ? null : exprNode.evaluate(env); 
  	
    throw new ControlSignalReturn(returnValue);
  }

}
