package org.openl.util;

import java.io.PrintStream;

/*
 * This static implementation of Report does not support multi-threading as it is
 * intended for design time analysis of rulesInMemory execution only
 */

public class ReportDT { //implements IReport { 
	
	Report report;
	String filename;
	PrintStream out;
	int numberOfRules;
	int tableNumber;
	String tableName;
	String tableType;
	String[] conditionDescriptions;
	String[] actionDescriptions;
	
//	static final String ruleColor = "'background-color:Navy;color:White'";
//	static final String condColor = "'background-color:Yellow'";
//	static final String actionColor = "'background-color:YellowGreen'";
	
	public ReportDT(Report report, int tableNumber) {
		this.report = report;
		this.tableNumber = tableNumber;
	}
	
	public String startDecisionTable(String tableName, String type, 
									 String[] conditionLabels, String[] conditionDescriptions,
									 String[] actionLabels, String[] actionDescriptions) {
		String number = "" + tableNumber;
		this.tableName = tableName;
		this.tableType = type;
		this.conditionDescriptions = conditionDescriptions;
		this.actionDescriptions = actionDescriptions;
//		if (tableNumber < 10)
//			number = "0"+tableNumber;
//		filename = report.runPath + "/Report" + number + "." + tableName + ".html";
//		//System.out.println("Generate " + filename + "...");
//		try {
//			out = new PrintStream(filename,"UTF-8");
//			
//		} catch (Exception e) {
//			System.out.println("Cannot create output file " + filename);
//		}
//		out.println("<meta http-equiv=\"Content-Type\" content=\"text/html;charset=utf-8\">");
//		out.println("<h3> Decision Table \"" + tableName + "\" (" + type + ") </h3>");
//		out.println("<table border='2' bordercolor='black' cellpadding='5'>");
//		// title row 1
//		out.println("<tr align='center'>");
//		out.println("<td style=" + Report.ruleColor + "> Executed </br> Rule</td>");
//		for (int i = 0; i < conditionLabels.length; i++) {
//			String label = conditionLabels[i];
//			if (label.startsWith("$"))
//				label = label.substring(1);
//			out.println("<td style=" + Report.ruleColor + "> " + label + " </td>");
//		}
//		for (int i = 0; i < actionLabels.length; i++) {
//			String label = actionLabels[i].trim();
//			if (label.startsWith("$"))
//				label = label.substring(1);
//			out.println("<td style=" + Report.ruleColor + "'> " + label + " </td>");
//		}
//		out.println("</tr>");
//		// title row 2
//		out.println("<tr align='center'>");
//		out.println("<th style=" + Report.ruleColor + "> # </th>");
//		for (int i = 0; i < conditionLabels.length; i++) {
//			out.println("<th style=" + Report.condColor + "> " + conditionDescriptions[i] + " </th>");
//		}
//		for (int i = 0; i < actionLabels.length; i++) {
//			out.println("<th style=" + Report.actionColor + "'> " + actionDescriptions[i] + " </th>");
//		}
//		out.println("</tr>");
		numberOfRules = 0;
		return filename;
	}
	
	public String getFilename() {
		return filename;
	}

	public void addRule(int ruleNumber) {
//		if (ruleNumber > 0)
//			out.println("</tr>"); // close previous rule
//		out.println("<tr align='center'>");
//		out.println("<td style=" + Report.ruleColor + "> " + (ruleNumber+1) + " </td>");
		numberOfRules++;
		if (!"Rule Sequence".equals(tableType))
			report.getReportInMemory().newRuleInMemory(tableName, ""+(ruleNumber+1));
	}
	
	public void addRuleCondition(String value, int conditionNumber) {
//		String v = value;
//		if (v == null) 
//			v = "-";
//		out.println("<td style=" + Report.condColor + "> " + v  + " </td>");
		
		if (!"Rule Sequence".equals(tableType))
			if (value != null)
				report.getReportInMemory().addCondition(conditionDescriptions[conditionNumber] + " " + value);
		
	}
	
	public void addRuleAction(String value, int actionNumber) {
//		String v = value;
//		if (v == null) 
//			v = "-";
//		out.println("<td style=" + Report.actionColor + "> " + v + " </td>");
		
		if (!"Rule Sequence".equals(tableType))
			if (value != null) {
				String varName = actionDescriptions[actionNumber];
				report.getReportInMemory().addAction(varName + " " + value);
			}
	}
	
	public void endDecisionTable() {
//		if (numberOfRules > 0)
//			out.println("</tr>"); // close the last rule
//		out.println("</table>");
//		out.close();
	}
	
}
