/*
 * Created on Nov 13, 2003
 *
 * Developed by Intelligent ChoicePoint Inc. 2003
 */
 
package org.openl.util;

import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import junit.framework.TestCase;

/**
 * @author snshor
 *
 */
public class TopoSortTester extends TestCase
{

	/**
	 * Constructor for TopoSortTester.
	 * @param arg0
	 */
	public TopoSortTester(String arg0)
	{
		super(arg0);
	}


	
	public void testMatrix()
	{
		List res;
		res = TopoSort.sort(  new int[][]{{7, 9},{ 3, 5}, {5, 9}, { 5, 7}});
		System.out.println("Matrix: " + res);
	}
	

	
	
	public void testArrays()
	{
		List res;
		res = TopoSort.sort(new int[]{7, 3, 5, 5}, new int[]{9, 5, 9, 7});
		System.out.println("Arrays: " + res);
	}
	
	public void testCycles()
	{
		TopoSort ts = new TopoSort();
		ts.addOrderedPair("7", "9");
		ts.addOrderedPair("3", "5");
		ts.addOrderedPair("5", "9");
		ts.addOrderedPair("5", "7");
		
		ts.addOrderedPair("7", "5");

		
		Vector v;
		try
		{
			v = ts.sort();
			for (Iterator iter = v.iterator(); iter.hasNext();)
			{
				System.out.println(iter.next());			
			}
		}
		catch (TopoSortCycleException e)
		{
			System.err.println(e.getMessage());
		}
		
	}
	

}
